/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

// Globals
var kitchen = Components.classes['@activestate.com/koCookbookService;1'].getService(Components.interfaces.koICookbookService);
var recipe = Components.classes['@activestate.com/koRecipe;1'].getService(Components.interfaces.koIRecipe);
var ingredient = arguments[1];
var cookbooknames;
var cookbooknumber;
var cookbook, category;
var item;
var recipeFrame, authenticatedBox, recipeTitleBox, recipeDescBox, recipeDiscussBox, cookbookList, categoryList;

var curView = window.arguments[2];
var langName = curView.py_inst.sourceFile.getLanguageBlockAtPosition(0).language;
var cookbookLanguageService = langName.getLanguageService(Components.interfaces.koICookbookLanguageService);
// Check language service first
if (cookbookLanguageService)
    cookbook = cookbookLanguageService.cookbookName;
else
    cookbook = '';

function onLoad() {
    koDoSetOKCancel(onOk, onCancel);

    // set up the UI elements
    recipeFrame = document.getElementById('recipeFrame');
    //authenticatedBox = document.getElementById('authenticated-box');
    recipeTitleBox = document.getElementById('recipeTitleBox');
    recipeDescBox = document.getElementById('recipeDescBox');
    recipeDiscussBox = document.getElementById('recipeDiscussBox');
    cookbookList = document.getElementById('cookbookList');
    categoryList = document.getElementById('categoryList');

    var cookie = window.arguments[0];
    // even though we already authenticated before launching the window, it needs to be done again for recipe submission
    var validated;
    try  {
        validated = kitchen.authenticate_with_cookie(cookie);
    }
    catch (e)  {
        logDebug("ASPN authenticate failure - cookbook.js:onLoad");
        validated = false;
    }
    if (!validated)  {
        opener.alertDialog("Recipe Submit : ASPN Authentication Failed (XML-RPC)");
        window.close();
        return;
    }
    setCookbookNames();

    SetWindowLocation();
    recipeTitleBox.focus();
}

function onUnload() {

}

function setCookbookNames()  {
    var arg1 = new Object();
    var arg2 = new Object();
    var cookbooknames = kitchen.getCookbookNames(arg1, arg2);
    var popup = document.createElement('menupopup');
    for (var i=0;i<cookbooknames.length;i++)  {
        item = document.createElement('menuitem');
        item.setAttribute('label', cookbooknames[i])
        popup.appendChild(item);
    }
    cookbookList.appendChild(popup);
    if (cookbook == '')  {
        cookbook = cookbookList.firstChild.firstChild.getAttribute('label');
    }
    cookbookList.selectedItem = cookbookList.getElementsByAttribute( "label", cookbook)[0];

    setCategories(cookbook);
}

function setCategories(cbook)  {
    var arg1 = new Object();
    var arg2 = new Object();    
    var categories = new Array();
    categories = kitchen.getCategories(cbook, arg1, arg2);
    // delete existing popup if there
    if (categoryList.hasChildNodes())
        categoryList.removeChild(categoryList.firstChild);
    var popup = document.createElement('menupopup');
    for (var i=0;i<categories.length;i++)  {
        item = document.createElement('menuitem');
        item.setAttribute('label', categories[i])
        popup.appendChild(item);
    }
    categoryList.appendChild(popup);
    var category = categoryList.firstChild.firstChild.getAttribute('label');
    categoryList.setAttribute('label', category);    
}

function submit()  {
    recipe.title = recipeTitleBox.value;
    recipe.summary = recipeDescBox.value;
    recipe.code = ingredient;
    recipe.discussion = recipeDiscussBox.value;
    recipe.category= categoryList.getAttribute('label');
    try {
        var response = kitchen.submitRecipe(cookbook, recipe);
        window.close();
        var retval = opener.alertDialog("Recipe Submitted. You can view it at - "+response,
                                         false, false, "Ok", "Go To Recipe");
        if (retval == "Go To Recipe")
            opener.OpenUrlInDefaultBrowser(response);
    }
    catch (e)  {
        opener.alertDialog("Recipe Submission Failed");
        window.close();
    }
}

function onCookbookChange()  {
    var newCookbook = cookbookList.selectedItem.getAttribute('label');
    setCategories(newCookbook);
}

function onCategoryChange()  {
    // Re-set the category
}

function onOk()  {
    submit();
    shutdown();
}

function onCancel()  {
    shutdown();
}

function shutdown()  {
    window.close();
    SaveWindowLocation();
}
