    /* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

/* a skeleton manager for the utility scintilla's
This controls a single scintilla, no tabs, etc. */

function ScintillaViewManager(scintillaId, mysci_widget) {
    if (arguments.length == 0) return;

    ViewManager.apply(this);
    this._sci_widget = mysci_widget;
    this._sci_widget.viewManager = this;
    this._sci_widget.scimoz_eventist = new eventist(this);
    this._scimoz = this._sci_widget.ISciMoz;
    this._scimoz.hookEvents( this._sci_widget.scimoz_eventist );

    // configure the scintilla buffer
    this.view = new ScintillaView(this, this._sci_widget);
    this.view.initWithLanguage("Text");
    this.view.url = this.view.leafName = null;
    this.view.activate();
}

// superclass: ViewManager
ScintillaViewManager.prototype = new ViewManager();
ScintillaViewManager.prototype.constructor = ScintillaViewManager;

ScintillaViewManager.prototype.destructor = function() {
    this.view.deactivate();
    this.view.destructor();
    this.view = null;
    this._scimoz.unhookEvents( this._sci_widget.scimoz_eventist );
}

ScintillaViewManager.prototype.setFocus = function() {
    this._sci_widget.focus();
    // this is a bit of a hack due to the delayed reflow.  The "focus()" method
    // above never makes it to SciMoz - so we set the focus property on SciMoz directly.
    this._scimoz.focus = true;
}

// main view manager interface

ScintillaViewManager.prototype.getCurrentView = function() {
    return this.view;
}

ScintillaViewManager.prototype.getNextView = function(/*bool*/ rotate /*=true*/) {
    return this.view;
}

ScintillaViewManager.prototype.getPreviousView = function(/*bool*/ rotate /*=true*/) {
    return this.view;
}

ScintillaViewManager.prototype.destroyView = function(view) {
    // remove the tab from the DOM tree.
    view.deactivate();
    view.destructor();
    view = null;
    return true;
}

ScintillaViewManager.prototype._createNewView = function(type, url, leafName, language, fileTemplate) {
    // perfTimer("ScintillaViewManager.createNewView", "start", true);
    this.view.activate();
    return this.view;
}

ScintillaViewManager.prototype.createNewViewWithURI = function(type, URI, leafName) {
    return this.view;
}    

ScintillaViewManager.prototype.createNewViewWithFileTemplate = function(type, template) {
    return this.view;
}
    
ScintillaViewManager.prototype.createNewViewWithLanguage = function(type, language) {
    return this.view;
}

ScintillaViewManager.prototype.renameView = function(view, url, leafName) {
}

// Change the appearance of a view's tab, etc. if it is dirty.
 
ScintillaViewManager.prototype.indicateIfDirty = function(view) {
}

ScintillaViewManager.prototype.doFileNew = function(language) {
    return this.view;
}

ScintillaViewManager.prototype.doNewFileTemplate = function(fileTemplate) {
    return this.view;
}

// This updates the list in the Window menu
ScintillaViewManager.prototype.updateWindowList = function(view, action, oldurl) {
}

ScintillaViewManager.prototype._hideScintilla = function() {
}

ScintillaViewManager.prototype._showScintilla = function() {
}

ScintillaViewManager.prototype.activate = function() {
    this._sci_widget.viewManager = this;
}
  
ScintillaViewManager.prototype.selectView = function(view) {
}

ScintillaViewManager.prototype.Observe = function (subject ,topic, fname) {
}
