/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

// Methods used by File settings and properties window

//---- globals

var hPrefWindow = null;
var initialTab = arguments[2];
var view = opener.getFocusedView();
var propsDone = false; // only do file properties once per session

var gOsSvc = Components.classes["@activestate.com/koOs;1"].
             getService(Components.interfaces.koIOs);
var gEncodingSvc = Components.classes["@activestate.com/koEncodingServices;1"].
                   getService(Components.interfaces.koIEncodingServices);

// Encoding
var encodingChanged = false;
var encodingList;
var lineEndingList;
var bombox;
var preserveExistingLineEndings;
var existingLineEndings;
var viewManager;

// Accessibility
var initiallyWriteable;
var accessible;

var desired_language = null;
var current_language;



//---- XXX cruft?

function _obs() {
    var observerSvc = Components.classes["@mozilla.org/observer-service;1"].
                      getService(Components.interfaces.nsIObserverService);
    observerSvc.AddObserver(this, 'currentView');
};

_obs.prototype = {
    Observe: function (view, topic, viewurl) {
        //nothing
    },

    QueryInterface: function (iid) {
        if (!iid.equals(nsIObserver))
            throw Components.results.NS_ERROR_NO_INTERFACE;
        return this;
    }
};


//---- routines for currentViewPrefs.xul

function SetupDialog() {
    // XXX should just pass the prefset directly to us.
    viewManager = window.arguments[1];
    if (!viewManager || !viewManager.getCurrentView()) {
        throw "Could not locate a preference set in the window args!";
    }
    var prefset = viewManager.getCurrentView().prefs;

    hPrefWindow = new koPrefWindow(null, prefset);
    if( !hPrefWindow )
        throw "failed to create prefwindow";
    hPrefWindow.onsinglepageload();
    koDoSetOKCancel(doOk, doCancel);
    changeTab("properties", true);
    handleLanguageSensitivities();
    SetWindowLocation();
}

function changeTab(tab, startup) {
    var tabControl = document.getElementById("fileTabbox");
    var tab_id;
    var focus_id;
    switch (tab) {
    case "settings":
    case "general":
        tab_id = "general_tab";
        focus_id = "showWhitespace";
        break;
    case "editing":
        tab_id = "editing_tab";
        break;
    case "indentation":
        tab_id = "indentation_tab";
        break;
    case "properties":
        tab_id = "properties_tab";
        focus_id = null;
        encodingList = document.getElementById('encodingList');
        lineEndingList = document.getElementById('lineEndingList');
        bombox = document.getElementById('bomCheckbox');
        preserveExistingLineEndings = document.getElementById('preserveExistingCheckbox');
        doFileProperties();
        changeLanguage(null);
        doEncoding();
        doLineEndings();
        propsDone = true;
        break;
// #if PRODUCT_TYPE == "professional"
    case 'scc':
        tab_id = 'scc_tab';
        doSCCProperties(viewManager.getCurrentView().item);
        break;
// #endif
    }
    if (startup) {
        // only change if tabs are being changed when the dialog is loading
        var tb = document.getElementById(tab_id);
        tabControl.selectedTab = tb;
    }
    if (focus_id)  {
        var t = document.getElementById(focus_id);
        t.focus();      
    }
}


/* This function handles the disabled/enabled state of UI elements 
 * depending on the language of the file open in the buffer
 */
function handleLanguageSensitivities()  {
    //XXX This handling is *kind of* bogus, but it works
    var linterLanguageService = view.py_inst.sourceFile.
          getLanguageBlockAtPosition(0).language.
          getLanguageService(Components.interfaces.koILinterLanguageService);

    var completionLanguageService = view.py_inst.sourceFile.
          getLanguageBlockAtPosition(0).language.
          getLanguageService(Components.interfaces.koICompletionLanguageService);
    
    if (!linterLanguageService) {
        document.getElementById('editUseLinting')
                .setAttribute('disabled', 'true');
    }
    // This currently works under the presumption that a language will implement
    // both autocomplete and call tips, and not just one
    if (!completionLanguageService)  {
        document.getElementById('editUseAutoComplete')
                .setAttribute('disabled', 'true');
        document.getElementById('editUseCallTips')
                .setAttribute('disabled', 'true');
    }
}    


// #if PRODUCT_TYPE == "professional"
function doSCCProperties(item) {
    var tag = 'None';
    switch (item.properties['scc']) {
        case 'p4':
            tag = "Perforce";
            break;
        case 'cvs':
            tag = "CVS";
            break;
        default:
            tag = "None";
    }
    document.getElementById('scc-scc').setAttribute('value', tag);
    if (tag != 'None') {
        document.getElementById('scc-status')
                .setAttribute('value', item.properties['status']);
        document.getElementById('scc-depotRevision')
                .setAttribute('value', item.properties['depotRevision']);
        document.getElementById('scc-myRevision')
                .setAttribute('value', item.properties['myRevision']);
    }
}
// #endif


function doFileProperties()  {
    if (propsDone == true)
        return;

    var url = view.url;
    var path = displayNameFromURL(url);
    var sizeStr = "Not Available";
    var ctimeStr = "Not Available";
    var mtimeStr = "Not Available";
    var atimeStr = "Not Available";
    var readable = false;
    var writeable = false;
    accessible = false;
    initiallyWriteable = false;

    if (url.search(/^(file\:)/) != -1)  {
        // Get the data we want from stat().
        var size, ctime, mtime, atime, mode;
        var statSucceeded;
        try {
            var modeObj = new Object();
            var inoObj = new Object();
            var nlinkObj = new Object();
            var uidObj = new Object();
            var gidObj = new Object();
            var sizeObj = new Object();
            var atimeObj = new Object();
            var mtimeObj = new Object();
            var ctimeObj = new Object();
            gOsSvc.stat(path, modeObj, inoObj, inoObj, nlinkObj, uidObj,
                        gidObj, sizeObj, atimeObj, mtimeObj, ctimeObj);
            size = sizeObj.value;
            ctime = ctimeObj.value;
            mtime = ctimeObj.value;
            atime = ctimeObj.value;
            mode = modeObj.value;
            statSucceeded = true;
        } catch (e) {
            statSucceeded = false;
        }

        // Process the stat() data for display.
        if (statSucceeded) {
            // Size info.
            sizeStr = size + " bytes";

            // Time info.
            var timeSvc = Components.classes["@activestate.com/koTime;1"].
                          getService(Components.interfaces.koITime);
            var prefSvc = Components.classes['@activestate.com/koPrefService;1'].
                          getService(Components.interfaces.koIPrefService);
            var format = prefSvc.prefs.getStringPref("defaultDateFormat");
            var timeTuple;
            timeTuple = timeSvc.localtime(ctime, new Object());
            ctimeStr = timeSvc.strftime(format, timeTuple.length, timeTuple);
            timeTuple = timeSvc.localtime(mtime, new Object());
            mtimeStr = timeSvc.strftime(format, timeTuple.length, timeTuple);
            timeTuple = timeSvc.localtime(atime, new Object());
            atimeStr = timeSvc.strftime(format, timeTuple.length, timeTuple);

            // Read-write status.
            readable = (mode & gOsSvc.S_IREAD) == gOsSvc.S_IREAD;
            writeable = (mode & gOsSvc.S_IWRITE) == gOsSvc.S_IWRITE;
            accessible = url.indexOf('file://') == 0 &&
                         gOsSvc.saneAccess(path, gOsSvc.W_OK);
        }
    }

    initiallyWriteable = writeable;
    
    // Update UI with data.
    document.getElementById("nameField")
            .setAttribute('value', makeLeafName(url));
    document.getElementById('sizeField').setAttribute('value', sizeStr);

    if (path != "") {
        document.getElementById('locationField').setAttribute('value', path);
        document.getElementById('createdField').setAttribute('value', ctimeStr);
        document.getElementById('modifiedField').setAttribute('value', mtimeStr);
        document.getElementById('accessedField').setAttribute('value', atimeStr);
    } else {
        document.getElementById('locationField').setAttribute('value', "Unsaved");
        document.getElementById('createdField').setAttribute('value', "Unsaved");
        document.getElementById('modifiedField').setAttribute('value', "Unsaved");
        document.getElementById('accessedField').setAttribute('value', "Unsaved");
    }

    var rwCheckbox = document.getElementById('rwCheckbox');
    if (accessible) {
        rwCheckbox.removeAttribute('disabled');
    }
    if (readable) {
        var readonly = !writeable;
        rwCheckbox.setAttribute('checked', readonly);
    } else  {
        var rwbox = document.getElementById('rwbox');
        rwbox.removeChild(rwbox.firstChild);
        var rwTextbox = document.getElementById('rwtext');
        rwTextbox.setAttribute("value",
            "This file has no read/write properties");
    }
}


function doEncoding()  {
    var current_encoding = view.py_inst.encoding;
    var count = new Object();
    var temp = new Object();
    gEncodingSvc.enumerateEncodings(temp,count);
    var encodings = temp.value;
    var i;
    var menuitem;

    var init_hierarchy = gEncodingSvc.encoding_hierarchy;

    var menupopup = opener.buildEncodingHierarchy(init_hierarchy, true,
                                                  'changeEncoding(this)');

    // Check to see if current encoding is in the list
    var enlistIndex = gEncodingSvc.get_encoding_index(current_encoding.python_encoding_name);
    if (enlistIndex == -1) { // not in list
        menuitem = document.createElementNS(XUL_NS, 'menuitem');
        menuitem.setAttribute('data', current_encoding.python_encoding_name);
        menuitem.setAttribute('label', current_encoding.friendly_encoding_name);
        menuitem.setAttribute('oncommand', 'changeEncoding(this)');
        menupopup.insertBefore(menuitem, menupopup.childNodes[0]);
    }
    
    encodingList.appendChild(menupopup);

    // Make sure current is selected
    if (enlistIndex == -1) {
        encodingList.selectedIndex = 0;
    } else {
        var item = document.getElementsByAttribute('data',
                    current_encoding.python_encoding_name)[0];
        encodingList.selectedItem = item;
    }

    var encodingInfo = gEncodingSvc.get_encoding_info(current_encoding.python_encoding_name);
    bombox.setAttribute('checked', current_encoding.byte_order_marker);
    doBOM(encodingInfo);
}


function changeLanguage(item) {
    if (item == null) { // startup - first time in
        current_language = view.py_inst.language;
        document.getElementById('langlist').selection = current_language;
    } else { // changing the pref
        desired_language = document.getElementById('langlist').selection
    }
}


function resetLanguage() {
    var registry = Components.classes["@activestate.com/koLanguageRegistryService;1"].
                   getService(Components.interfaces.koILanguageRegistryService);
    var prefset = view.prefs;
    prefset.deletePref("language");
    desired_language = registry.suggestLanguageForFile(displayNameFromURL(view.url));
    var langlist = document.getElementById('langlist');
    langlist.selection = desired_language;
}


function doBOM(encodingInfo)  {
    var bom = encodingInfo.supports_byte_order_marker;
    if (bom) {
        bombox.setAttribute('disabled', 'false');
    } else {
        bombox.setAttribute('disabled', 'true');
    }
}


function changeEncoding(item)  {
    doBOM(gEncodingSvc.get_encoding_info(item.getAttribute('data')));
    //encodingChanged = true;
}


function setEncoding()  {
    var koEncoding = Components.classes["@activestate.com/koEncoding;1"].
                     createInstance(Components.interfaces.koIEncoding);

    koEncoding.python_encoding_name = encodingList.selectedItem.getAttribute('data');
    koEncoding.byte_order_marker = (bombox.getAttribute('disabled') == 'false'
                                    && bombox.getAttribute('checked') == 'true')

    var lang = view.py_inst.language;
    var language = view.py_inst.sourceFile.
                    getLanguageBlockAtPosition(0).language;

    var warning = language.getEncodingWarning(koEncoding);
    
    if (warning == "" || 
        opener.alertDialog(warning + ' Are you sure that you want to change the encoding?',
                           false, false, "Ok", "Cancel") == "Ok"
       ) 
    {
        try {
            view.py_inst.encoding = koEncoding;
        } catch(e) {
            if (opener.alertDialog("Unable to change file encoding to "+
                    koEncoding.python_encoding_name+".  "+
                    "The file may have characters that do not fit in "+
                    "this encoding.  Would you like to remove the "+
                    "characters and force the file to the encoding "+
                    "you have choosen?", false, false, "Ok", "Cancel") 
                == "Ok")  {
                
                try {
                    view.py_inst.forceEncodingFromEncodingName(koEncoding.python_encoding_name);
                } catch(e) {
                    opener.alertDialog("Unable to complete encoding conversion");
                    logError("Unable to change file encoding: "+e);
                }
            } else {
                logError("Unable to change file encoding: "+e);
            }
        }
        return true;
    }
    
    return false;
}


function doLineEndings()  {
    var menupopup = document.createElementNS(XUL_NS, 'menupopup');
    
    var menuitem = document.createElementNS(XUL_NS, 'menuitem');
    menuitem.setAttribute('label', 'DOS/Windows (\\r\\n)');
    menuitem.setAttribute('data', view.py_inst.EOL_CRLF.toString());
    menupopup.appendChild(menuitem);
    
    menuitem = document.createElementNS(XUL_NS, 'menuitem');
    menuitem.setAttribute('label', 'Macintosh (\\r)');
    menuitem.setAttribute('data', view.py_inst.EOL_CR.toString());
    menupopup.appendChild(menuitem);

    menuitem = document.createElementNS(XUL_NS, 'menuitem');
    menuitem.setAttribute('label', 'UNIX (\\n)');
    menuitem.setAttribute('data', view.py_inst.EOL_LF.toString());
    menupopup.appendChild(menuitem);

    lineEndingList.appendChild(menupopup);

    if (view.py_inst.new_line_endings == view.py_inst.EOL_LF) {
        lineEndingList.selectedIndex = 2;
    } else if (view.py_inst.new_line_endings == view.py_inst.EOL_CR) {
        lineEndingList.selectedIndex = 1;
    } else if (view.py_inst.new_line_endings == view.py_inst.EOL_CRLF) {
        lineEndingList.selectedIndex = 0;
    }

    // Remembering this will save us an expensive operation later
    existingLineEndings = view.py_inst.existing_line_endings;
    preserveExistingLineEndings.setAttribute('checked',
        existingLineEndings == view.py_inst.EOL_MIXED);
}


function _setResult(res) {
    if (window.arguments && window.arguments[0]) {
        window.arguments[0].res=res;
    }
    return true;
}


function doOk() {
    if (!hPrefWindow.onSinglePageOK()) {
        return false;
    }
    if (propsDone == true)  {
        if (!setEncoding())  {
            return false;
        }
        
        var newLineEndings = new Number(lineEndingList.selectedItem.getAttribute('data'));
        view.py_inst.new_line_endings = newLineEndings;
        if (preserveExistingLineEndings.getAttribute('checked') != 'true' &&
            newLineEndings != existingLineEndings ) {
            view.py_inst.existing_line_endings = newLineEndings;
        }
    }
    if (desired_language && desired_language != current_language) {
        view.viewAs(desired_language);
    }
    if (accessible &&
        initiallyWriteable != !(document.getElementById('rwCheckbox').checked)
       )
    {
        var write = !document.getElementById('rwCheckbox').checked;
        if (gOsSvc.setWriteability(displayNameFromURL(view.url),
                                   !initiallyWriteable) == 0)
        {
            alertDialog("Could not change read-only status.");
        }
    }
    _setResult("ok");
    return true;
}


function doCancel() { 
  _setResult("cancel");
  return true;
}


function doUnload()  {
    SaveWindowLocation();
}


