/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

var dialog;     // Quick access to document/form elements.
var gFindInst;   // nsIWebBrowserFind that we're going to use
var findService;

function initDialogObject()
{
  // get the find service, which stores global find state
  findService = Components.classes["@mozilla.org/find/find_service;1"]
                         .getService(Components.interfaces.nsIFindService);
  // Create dialog object and initialize.
  dialog = new Object;
  dialog.findKey         = document.getElementById("dialog.findKey");
  dialog.caseSensitive   = document.getElementById("dialog.caseSensitive");
  dialog.wrap            = document.getElementById("dialog.wrap");
  dialog.searchBackwards = document.getElementById("dialog.searchBackwards");
  dialog.find            = document.getElementById("ok");
  dialog.bundle          = null;

  // Move dialog to center, if it not been shown before
  var windowElement = document.getElementById("helpFindDialog");
  if (!windowElement.hasAttribute("screenX") || !windowElement.hasAttribute("screenY"))
  {
    sizeToContent();
    koMoveToAlertPosition();
  }
}

function fillDialog()
{
  // Set initial dialog field contents.
  dialog.findKey.value           = findService.searchString;
  dialog.caseSensitive.checked   = findService.matchCase;
  dialog.wrap.checked            = findService.wrapFind;
  dialog.searchBackwards.checked = findService.findBackwards;
}

function saveFindData()
{
  // Set data attributes per user input.
  findService.searchString  = dialog.findKey.value;
  findService.matchCase     = dialog.caseSensitive.checked;
  findService.wrapFind      = dialog.wrap.checked;
  findService.findBackwards = dialog.searchBackwards.checked;
}

function onLoad()
{
  initDialogObject();

  // Change "OK" to "Find".
  dialog.find.label = document.getElementById("fBLT").getAttribute("label");

  // Setup the dialogOverlay.xul button handlers.
  doSetOKCancel(onOK, onCancel);

  // get the find instance
  gFindInst = window.arguments[0];

  fillDialog();
  doEnabling();

  if (dialog.findKey.value)
    dialog.findKey.select();
  else
    dialog.findKey.focus();
}

function onUnload()
{
    window.opener.findDialog = 0;
}

function onOK()
{
  // Transfer dialog contents to the find service.
  saveFindData();

  // set up the find instance
  gFindInst.searchString  = dialog.findKey.value;
  gFindInst.matchCase     = dialog.caseSensitive.checked;
  gFindInst.wrapFind      = dialog.wrap.checked;
  gFindInst.findBackwards = dialog.searchBackwards.checked;
  
  // Search.
  var result = gFindInst.findNext();

  if (!result)
  {
    if (!dialog.bundle)
      dialog.bundle = document.getElementById("helpBundle");
      window.alert(dialog.bundle.getString("notFoundWarning"));
  }
}

function onCancel()
{
  // Close the window.
  return true;
}

function doEnabling()
{
  dialog.find.disabled = !dialog.findKey.value;
}
