/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

// Komodo specific dialog functions.
// Note that our XUL overlay still refers to the global "dialogOverlay.js"
// which contains most of the code.  This is only for enhancements to
// the Mozilla defaults.

// Constants and global variables
const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
var languages;

var doOKFunction = 0;
var doCancelFunction = 0;
var doButton2Function = 0;
var doButton3Function = 0;

function _doSetKey(button_id, key_id) {
    var element = document.getElementById(button_id);
    var key = document.getElementById(key_id);
    if (element && key && !element.hasAttribute("collapsed")) {
        var ch = element.getAttribute("value").charAt(0);
        key.setAttribute("key", ch.toLowerCase());
        key.setAttribute("accesskey", ch.toLowerCase());
    }
}
function koDoSetOKCancel(okFunc, cancelFunc, button2Func, button3Func )
{
    //doSetOKCancel(okFunc, cancelFunc, button2Func, button3Func);
    //_doSetKey("ok", "key_ok");
    //_doSetKey("cancel", "key_cancel");
    //_doSetKey("Button2", "key_button2");
    //_doSetKey("Button3", "key_button3");
    doOKFunction = okFunc;
    doCancelFunction = cancelFunc;
    doButton2Function = button2Func;
    doButton3Function = button3Func;
    
    setupButtonAccessKeys();
}

function doOKButton()
{
    var close = true;
          
          if ( doOKFunction )
                  close = doOKFunction();
          
          if (close && top)
                  top.window.close();
}
  
function doCancelButton()
{
        var close = true;
        
        if ( doCancelFunction )
                close = doCancelFunction();
        
        if (close && top)
                top.window.close();
}

function doButton2()
{
        var close = true;
        
        if ( doButton2Function )
                close = doButton2Function();
        
        if (close && top)
                top.window.close();
}

function doButton3()
{
        var close = true;
        
        if ( doButton3Function )
                close = doButton3Function();
        
        if (close && top)
                top.window.close();
}

function _doesKeyMatchButton(key, but_id) {
    var button = document.getElementById(but_id);
    var label = button.getAttribute('label').toLowerCase();
    var ready = !button.disabled && (!button.getAttribute('collapsed')==1);
    return ready && (key.getAttribute("key") == label.charAt(0));
}
// XXX The next 2 functions (doButtonViaKey and setupButtonAccessKeys)
// are a hack until mozilla handles accesskeys better
// This only applies to dialogs that use the ok/cancel buttons from 
// the platform overlays, and can handle yes/no.
function doButtonViaKey( event, realHandler, key ) {
    // We only want to process the key if the is not in a
    // "text" or "textarea", or many other widgets!
    var targetTag = event.target.tagName.toLowerCase();
    if (targetTag == "textbox" || targetTag == "text" || targetTag == "menulist" || targetTag == "tree" ||
        targetTag == "cgiprefs" || targetTag == "langlist")
        return;
    if (_doesKeyMatchButton(key, "ok") || _doesKeyMatchButton(key, "cancel") || _doesKeyMatchButton(key, "Button2")) {
        realHandler();
    }
    return;
}

function _doAccessKey(but_id) {
    var button = document.getElementById(but_id);
    if (!button)
        return;
    var label = button.getAttribute('label').toLowerCase();
    button.setAttribute('accesskey', label.charAt(0));
}

function setupButtonAccessKeys()  {
    _doAccessKey("ok");
    _doAccessKey("cancel");
    _doAccessKey("Button2");
}

function doDefaultButton() {
    // What does this function do?
    // 1) If button has focus, execute function hooked up to it
    // 2) If no button is focused, do default button (if not disabled).
    // 3) If no button is focused, and the default button is disabled, do nothing.
    var element = document.commandDispatcher.focusedElement;
    if (element && element.nodeName == "button" && !element.disabled)  {
        var elId = element.getAttribute("id");
        switch (elId)  {
            case "ok" :
                doOKButton();
                break;
            case "cancel" :
                doCancelButton();
                break;
            case "Button2" :
                doButton2();
                break;
            case "Button3" :
                doButton3();
                break;
        }
    }
    else if (!element || !element.disabled)  {
      element = document.getElementById("ok");
      if (element.hasAttribute("default") && element.getAttribute("default"))
          doOKButton();
      else {
          element = document.getElementById("cancel");
          if (element.hasAttribute("default") && element.getAttribute("default")) {
              doCancelButton();
          } else {
              element = document.getElementById("Button2");
              if (element.hasAttribute("default") && element.getAttribute("default")) {
                  doButton2();
              } else {
                  element = document.getElementById("Button3");
                  if (element.hasAttribute("default") && element.getAttribute("default"))
                      doButton3();
              }
          }
      }
   }
   else  {
       // do nothing here
       return;
   }
}

function doEnter() {
    // 1) If button has focus, execute 'oncommand' handler
    // 2) If no button is focused, do default button (if not disabled).
    // 3) If no button is focused, and the default button is disabled, do nothing.
    // NOTE: This presumes that if a button has something to do it *is*
    // its oncommand handler (i.e. 'onclick' is no good)
    var element = document.commandDispatcher.focusedElement;
    var command = null;
    if (element && element.nodeName == "button") {
        // a button has the focus:
        // - run its oncommand handler
        if (!element.disabled) {
            command = element.getAttribute("oncommand");
        }
    }
    else {
        // no button has the focus:
        // - do default button's oncommand if there is one
        var buttons = document.getElementsByTagName("button");
        for (var i=0; i<buttons.length; i++) {
            var button = buttons[i];
            if (!button.disabled
                && button.hasAttribute("default")
                && buttons[i].getAttribute("default"))
            {
                command = buttons[i].getAttribute('oncommand');
            }
        }
    }
    if (command) {
        eval(command);
    }
}

function koMoveToAlertPosition()
{
    // hack. we need this so the window has something like its final size
    if (window.outerWidth == 1) {
        dump("Trying to position a sizeless window; caller should have called sizeToContent() or sizeTo(). See bug 75649.\n");
        sizeToContent();
    }
    var xOffset = (opener.outerWidth - window.outerWidth) / 2;
    var yOffset = opener.outerHeight / 5;
    var newX = opener.screenX + xOffset;
    var newY = opener.screenY + yOffset;
    // ensure the window is fully onscreen (if smaller than the screen)
    if (newX < screen.availLeft)
        newX = screen.availLeft + 20;
    if ((newX + window.outerWidth) > (screen.availLeft + screen.availWidth))
        newX = (screen.availLeft + screen.availWidth) - window.outerWidth - 20;
    if (newY < screen.availTop)
        newY = screen.availTop + 20;
    if ((newY + window.outerHeight) > (screen.availTop + screen.availHeight))
        newY = (screen.availTop + screen.availHeight) - window.outerHeight - 60;
    window.moveTo( newX, newY );


}

function koCenterWindowOnScreen() {
  window.sizeToContent();
  var w = screen.availWidth;
  var h = screen.availHeight;
  var popW = window.outerWidth;
  var popH = window.outerHeight;
  var topPos = (w-popW)/2;
  var leftPos = (h-popH) * (1.0-0.62);
  window.moveTo(topPos, leftPos);
}

function SetWindowLocation()
{
   var gLocation = document.getElementById("location");
   if (gLocation)
   {
     window.screenX = Math.max(0, Math.min(window.opener.screenX + Number(gLocation.getAttribute("offsetX")),
                                           screen.availWidth - window.outerWidth));
     window.screenY = Math.max(0, Math.min(window.opener.screenY + Number(gLocation.getAttribute("offsetY")),
                                           screen.availHeight - window.outerHeight));
  }
}
 
function SaveWindowLocation()
{
   var gLocation = document.getElementById("location");
   if (gLocation)
   {
     var newOffsetX = window.screenX - window.opener.screenX;
     var newOffsetY = window.screenY - window.opener.screenY;
     gLocation.setAttribute("offsetX", window.screenX - window.opener.screenX);
     gLocation.setAttribute("offsetY", window.screenY - window.opener.screenY);
   }
}

function FillInTooltip ( tipElement )
{
  //alert("Filling in tooltip");
  var retVal = false;
  var textNode = document.getElementById("TOOLTIP-tooltipText");
  while (textNode.hasChildNodes())
    textNode.removeChild(textNode.firstChild);
  if (textNode) {
    var tipText = tipElement.getAttribute("tooltiptext");
    if (tipText) {
      var node = document.createTextNode(tipText);
      textNode.appendChild(node);
      retVal = true;
    }
  }
  return retVal;
}

// Tab back/forward utility for dialogs that use them
function tabAdvance(tabsId, direction) {
    var tabs = document.getElementById(tabsId);
    tabs.advanceSelectedTab(direction);
}
