/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

// globals
var gKomodoBundle = document.getElementById("bundle_komodo");

var koCmdUpdateCache = [];
var koCmdUpdateCount = 0;
var koCmdUpdateTotalTime = 0;

var koCmdUpdateCounts = [];
var koCmdUpdateTotalTimes = [];
const koKeepUpdateTimes = false;

var globalPrefService = Components.classes["@activestate.com/koPrefService;1"].
        getService(Components.interfaces.koIPrefService);
var prefs = globalPrefService.prefs;

var os = Components.classes["@activestate.com/koOs;1"].getService(Components.interfaces.koIOs);
      
var encrypted = "";
var pref = Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPref);

// global vars for passing data to help.xul
var gHelpArg_StartPage;
var gHelpArg_Align;

/* Tooltip Utilities */

// Replica of version in globalOverlay.js - setTooltipText(aID, aTooltipText)
function kosetTooltipText(aID, aTooltipText)
{
    var element = document.getElementById(aID);
    if (element)
        element.setAttribute("tooltiptext", aTooltipText);
}

function koFillInTooltip (tipElement)
{
    if (tipElement.tagName == "scintilla") {
        var txt = tipElement.getTooltipText();
        if (txt)  {
            kosetTooltipText(tipElement.id, txt)
        }
        else  {
            tipElement.removeAttribute('tooltiptext');
        }
    }

    // Call the default Mozilla version.
    return FillInTooltip(tipElement);
}

/* End Tooltip Utilities */

// Returns "true" is the command is a "checkbox" type command - ie,
// if supported, the "isCommandEnabled()" function determines the check-state,
// rather than the grayness of the command itself.
function koIsCheckCommand(id)
{
    var node = top.document.getElementById(id);
    if(node) {
        var t = node.getAttribute("type").toLowerCase();
        if(t == "checkbox" || t == "radio")
            return true;
        else {
            return node.hasAttribute("toggled");
        }
    }
    return false;
}

// Returns true if the command is enabled or checked.
function koIsCommandEnabled(id) {
    var node = top.document.getElementById(id);
    if ( node ) {
        if (koIsCheckCommand(id))
            return node.getAttribute("checked")
        return !node.getAttribute("disabled")
    }
    logWarning("isCommandEnabled - no ID '" + id + "'\n");
    return false;
}

// Returns true if the command was handled (even if it is disabled),
// or false if no handler can be found, or an error occurs.
function koGoUpdateCommand(command, controller /* = null */) {
//   try {
      var found = false;
      if (controller == undefined || controller == null) {
          controller = koGetControllerForCommand(command);
      }

      var enabled = false;

      if(controller) {
        enabled = controller.isCommandEnabled(command);
        found = true;
      }
      koGoSetCommandEnabled(command, found, enabled);
   /****
   }
   catch (e) {
      dump("An error occurred updating the "+command+" command\n");
      dump("And the error was: " + e + "\n");
   }
***/
   return found;
}

function koGoUpdateCommandsetItems(commandset) {
   if (koKeepUpdateTimes)
      t1 = new Date();
   var childNodes = commandset.childNodes;
   var length = childNodes.length;
   for (var i = 0; i < length; i++)
   {
      var commandID = childNodes[i].id;
      if (commandID)
      {
        if (!koGoUpdateCommand(commandID)) {
// This can be handy to tune XUL loading...
//          logWarning("koGoUpdateCommandsetItems - " + commandset.id +
//                          " - command ID '" + commandID + "' - no controller available!\n");
         }
      }
      else {
        logWarning("koGoUpdateCommandsetItems - " + commandset.id + " - element no " + i + " has no ID!!\n");
        introspect(childNodes[i]);
        dump('-- end of dump --\n');
      }
   }
   if (koKeepUpdateTimes) {
       t2 = new Date();
    
       // Update some performance counters.
       koCmdUpdateCount++;
       koCmdUpdateTotalTime += (t2 - t1);
    
       var id = commandset.id;
    
       if(!koCmdUpdateCounts[id]) {
           koCmdUpdateCounts[id] = 0;
       }
       if(!koCmdUpdateTotalTimes[id]) {
           koCmdUpdateTotalTimes[id] = 0;
       }
    
       koCmdUpdateCounts[id]++;
       koCmdUpdateTotalTimes[id] += (t2 - t1);

       dump("Average update time: " +
            (koCmdUpdateTotalTime / koCmdUpdateCount) + "\n");
       dump("Average for " + id +
            ": " + (koCmdUpdateTotalTimes[id]/koCmdUpdateCounts[id]) + "\n");
       dump("Average for each " + length + " of " + id + " elements: " +
            (koCmdUpdateTotalTimes[id]/koCmdUpdateCounts[id]/length) + "\n");
   }
}

// *sigh* - plugin focus issues are causing us grief yet again
// If we can find no controller, check and see if a plugin has focus, 
// and if so, see if the parent widget's controller supports it.
function koGetControllerForCommand(command) {
    var commandDispatcher = top.document.commandDispatcher
    var focusedElement = commandDispatcher.focusedElement;
    var controller;
    // If html:embed tag, *must* go directly to its controller.
    // Can not use the commandDispatcher first, as some builtin commands
    // will always be satisfied, and never defer to the plugin.
    if (focusedElement && (focusedElement.tagName == "html:embed")) {
        controller = focusedElement.parentNode.controllers.getControllerForCommand(command);
        // dump("koGetControllerForCommand - have plugin - parent said " + controller + "\n");
    } 
    if (!controller)
        controller = commandDispatcher.getControllerForCommand(command);
    //var controller = window.controllers.getControllerForCommand(command);
//    dump("getcontroller for " + command + " while tag " + focusedElement.tagName + "found " +controller + "\n");
    return controller
}

// Execute a command.
function koGoDoCommand(command) {
   var rc = false;
   try {
      var controller = koGetControllerForCommand(command);
//      dump("koGoDoCommand for " + command + " found controller " + controller + "\n");
      if (controller) {
        // gMacroMgr can be undefined if we're not in the main komodo.xul window (e.g. Rx commands)
        if (typeof(gMacroMgr) != 'undefined' && gMacroMgr && gMacroMgr.recording) {
            if (! document.getElementById(command).hasAttribute('interactive')) {
                gMacroMgr.appendCommand(command);
            }
        }
        if (koIsCheckCommand(command)) {
            // For a check command, we do the command, then re-update it,
            // (as presumably the state has now toggled)
            controller.doCommand(command);
            koGoUpdateCommand(command, controller)
        } else {
            controller.doCommand(command);
        }
        rc = true;
      } // if controller
      else {
        logWarning("Command " + command + " has no controller.");
      }
   } // try
   catch (e) {
      logError("An error occurred executing the "+command+" command\n" + e);
   }
   return rc;
}

function koGoSetCommandEnabled(id, supported, enabled)
{
    var node = top.document.getElementById(id);

    if ( node ) {
        var really_enabled = supported;
        if (supported && koIsCheckCommand(id)) {
            if ( enabled ) {
                node.setAttribute('checked', 'true');
                node.setAttribute('toggled', 'true');
            }
            else {
                node.setAttribute('checked', 'false');
                node.setAttribute('toggled', 'false');
            }
        } else {
            really_enabled = enabled;
        }
        if (really_enabled)
            node.removeAttribute("disabled");
        else
            node.setAttribute('disabled', 'true');
    } else {
	logWarning("Attempting to update command '" + id + "', but no node available\n");
    }
}

function koRequestUpdateCommands(event) {
  // poor mans version, we could be more intelligent by
  // eliminate repeated requests and hooking into the nonexistant
  // Mozilla idle mechanism. Calling setTimeout() causes the execution
  // to be queued and done later, thus avoiding blocking the UI for
  // long streches.
    // window.updateCommands(event);

  // Cue up a bunch of events to update and do it all later on.
  koSetEventPending(event);
}

function koSetEventPending(event) {
  if (event != null) {
    if (event in koCmdUpdateCache) return; // don't start a new timer if the event is already cached
    koCmdUpdateCache[event] = 1;
  }
  window.setTimeout('koEatAPendingEvent()', 100);
}

function koEatAPendingEvent() {
  // Process one of the items, and queue the next.
  // *sigh* - how do we know how many items?
  for(event in koCmdUpdateCache) {
    window.updateCommands(event);
    delete(koCmdUpdateCache[event]);
    break;
  }
  // If we have at least one more item, set the timer.
  // XXX is this realy necessary?  We set a timer for EACH event we add to the cache, I
  // think this whole thing needs to be rewritten.  Setting an additional timer here seems
  // like well end up with more timers than events in the cache.  SMC
  //for(event in koCmdUpdateCache) {
  //  koSetEventPending(null);
  //  break;
  //}
}

function koGoUpdateScintillaCommands(commandset) {
  // NOTE: This code assumes the LAST controller
  var childNodes = commandset.childNodes;
  var length = childNodes.length;

  var focusedElement = top.document.commandDispatcher.focusedElement;
  // The plugin itself can have focus sometimes (but it is never told)
  // pretend it is the parent)
  var commandID, i;
  if (focusedElement) {
      if (focusedElement.tagName == "html:embed")
          focusedElement = focusedElement.parentNode
      if (focusedElement.tagName!="scintilla") {
        for (i = 0; i < length; i++) {
          commandID = childNodes[i].id;
          koGoSetCommandEnabled(commandID, true, false);
        }
      } else {
          var controller = focusedElement.controllers.getControllerAt(focusedElement.controllers.getControllerCount()-1);
          for (i = 0; i < length; i++) {
            commandID = childNodes[i].id;
            koGoUpdateCommand(commandID, controller);
          }
      }
  } else {
      // We need to disable the Scintilla commands when scintilla loses focus
      for (i = 0; i < length; i++) {
        commandID = childNodes[i].id;
        koGoSetCommandEnabled(commandID, false, false);
      }
  }
}

function func_wsBookmarks()  {
    openWindowUniqueInstance("chrome://komodo/content/webservices/bookmarks.xul", 
                "komodo_wsbookmarks",
                "chrome,dialog,dependent");
}    

function func_toolsChatzilla() {
  openWindowMultipleInstance("chrome://chatzilla/content/chatzilla.xul", 
			     'irc:chatzilla', 
                             "chrome,menubar,toolbar,resizable",
                             '');
}

function func_toolsMozilla() {
	// Open with user's Mozilla default page
    pref = Components.classes["@mozilla.org/preferences;1"].getService();
    var homepage; 
    try {
      homepage = pref.getLocalizedUnicharPref("browser.startup.homepage");
    }
    catch(e) {
      homepage = null;
    }
	openWindowMultipleInstance(getBrowserURL(),
	                    'navigator:browser',
                            'chrome,all,resizable,dialog=no',
                            homepage);
}

function func_toolsRunCommand() {
    // Transfer focus to the hidden input buffer to capture keystrokes from the
    // user while run.xul is loading.  (Get the current view before calling
    // inputbuffer start so we have the correct focus coming out of the
    // dialog.)
    var v = getFocusedView();
    InputBuffer_Start();
    openWindowUniqueInstance("chrome://komodo/content/run/run.xul", 
                             "komodo_run", 
                             "chrome,dialog,dependent");
}

function HelpObserver() {
    this.observerSvc = Components.classes["@mozilla.org/observer-service;1"].
	               getService(Components.interfaces.nsIObserverService);
    this.observerSvc.AddObserver(this, "help");
};
HelpObserver.prototype = {
  Observe: function (set, topic, page) {
    // Handle the mru lists
    if (topic=="help" && page != "") {
        func_helpHelp(page);
    }
  },
  destroy: function () {
    this.observerSvc.RemoveObserver(this, "help");
  }
};

function doHelp(page) {
    observerSvc = Components.classes["@mozilla.org/observer-service;1"].
          getService(Components.interfaces.nsIObserverService);
    observerSvc.Notify(null, "help", page);
}

function func_helpHelp(page) {
  gHelpArg_StartPage = undefined;
  if (page) {
      gHelpArg_StartPage = page;
  }
  gHelpArg_Align = false;
  openWindowUniqueInstance("chrome://komodo/content/help/help.xul",
                    'komodo_help',
                    'chrome,all,resizable,scrollbars,dependent=true,dialog=no'); 
}

function func_helpTutorials(tutorial /* =null */)
{
    // Open the Tutorial in the help browser and align the two windows side
    // by side.
    //    "tutorial" can optionally be used to specify a particular tutorial
    //        to start with. Currently valid values are "perl", "python", 
    //        "php", "xslt", and null (to go to Tutorial home page).
    if (tutorial) {
        gHelpArg_StartPage = "chrome://komodo/content/doc/komodo/tutorial/"+
                             tutorial+"tut/"+tutorial+"tut.html";
    } else {
        gHelpArg_StartPage = "chrome://komodo/content/doc/komodo/tutorial/komtutorials.html";
    }
    gHelpArg_Align = true;
    const nsIWindowMediator = Components.interfaces.nsIWindowMediator;
    const MEDIATOR_CONTRACTID = "@mozilla.org/rdf/datasource;1?name=window-mediator";
    var windowManager = Components.classes[MEDIATOR_CONTRACTID].getService();
    var helpWindow = windowManager.getMostRecentWindow('komodo_help');
    if (helpWindow) {
        // XXX it'd be nice to have a way to change the help page of an already
        // open window instead of closing and restarting it.
        helpWindow.close();
    }

    helpWindow = openWindowUniqueInstance("chrome://komodo/content/help/help.xul",
                                   'komodo_help',
                                   'chrome,all,resizable,scrollbars,dependent=true,dialog=no');
}

function func_helpTipOfTheDay() {
    openWindowUniqueInstance(
        "chrome://komodo/content/tipoftheday/tipoftheday.xul",
        "komodo_tip",
        "chrome,dialog,dependent");
}


function func_helpPerlRef_Local() {
    var perlInfoSvc = Components.classes["@activestate.com/koPerlInfoEx;1"]
                      .getService(Components.interfaces.koIAppInfoEx);
    OpenUrlInDefaultBrowser(perlInfoSvc.localHelpFile);
}

function func_helpPerlRef_Web() {
    var perlInfoSvc = Components.classes["@activestate.com/koPerlInfoEx;1"]
                      .getService(Components.interfaces.koIAppInfoEx);
    OpenUrlInDefaultBrowser(perlInfoSvc.webHelpURL);
}

function func_helpPerlMailingLists() {
    var url = "http://aspn.activestate.com/ASPN/Mail?topic=Perl";
    OpenUrlInDefaultBrowser(url);
}

function func_helpPythonRef_Local() {
    var pythonInfoSvc = Components.classes["@activestate.com/koPythonInfoEx;1"]
                      .getService(Components.interfaces.koIAppInfoEx);
    OpenUrlInDefaultBrowser(pythonInfoSvc.localHelpFile);
}

function func_helpPythonRef_Web() {
    var pythonInfoSvc = Components.classes["@activestate.com/koPythonInfoEx;1"]
                        .getService(Components.interfaces.koIAppInfoEx);
    OpenUrlInDefaultBrowser(pythonInfoSvc.webHelpURL);
}

function func_helpPythonMailingLists() {
    var url = "http://aspn.activestate.com/ASPN/Mail?topic=Python";
    OpenUrlInDefaultBrowser(url);
}

function func_helpPHPRef_Web() {
    var phpInfoSvc = Components.classes["@activestate.com/koPHPInfoEx;1"]
                     .getService(Components.interfaces.koIPHPInfoEx);
    OpenUrlInDefaultBrowser(phpInfoSvc.webHelpURL);
}

function func_helpPHPMailingLists() {
    var url = "http://aspn.activestate.com/ASPN/Mail?topic=PHP";
    OpenUrlInDefaultBrowser(url);
}

function func_helpTclRef_Local() {
    var tclInfoSvc = Components.classes["@activestate.com/koTclInfoEx;1"]
                      .getService(Components.interfaces.koIAppInfoEx);
    OpenUrlInDefaultBrowser(tclInfoSvc.localHelpFile);
}

function func_helpTclRef_Web() {
    var tclInfoSvc = Components.classes["@activestate.com/koTclInfoEx;1"]
                     .getService(Components.interfaces.koIAppInfoEx);
    OpenUrlInDefaultBrowser(tclInfoSvc.webHelpURL);
}

function func_helpTclMailingLists() {
    var url = "http://aspn.activestate.com/ASPN/Mail?topic=Tcl";
    OpenUrlInDefaultBrowser(url);
}

function func_helpXSLTMailingLists() {
    var url = "http://aspn.activestate.com/ASPN/Mail?topic=XSLT";
    OpenUrlInDefaultBrowser(url);
}


function UpdateHelpLanguagesPopup() {
    // Hide or show the local help entries in the Help->Languages popup
    // depending on whether an actually help file to launch can be found.
    var perlInfoSvc = Components.classes['@activestate.com/koPerlInfoEx;1'].
                      getService(Components.interfaces.koIAppInfoEx);
    var perlWidget = document.getElementById("menu_helpPerlRef_Local");
    var perlHelpFile = perlInfoSvc.localHelpFile;
    if (perlHelpFile) {
        perlWidget.removeAttribute("collapsed");
    } else {
        perlWidget.setAttribute("collapsed", true);
    }

    var pythonInfoSvc = Components.classes['@activestate.com/koPythonInfoEx;1'].
                        getService(Components.interfaces.koIAppInfoEx);
    var pythonWidget = document.getElementById("menu_helpPythonRef_Local");
    var pythonHelpFile = pythonInfoSvc.localHelpFile;
    if (pythonHelpFile) {
        pythonWidget.removeAttribute("collapsed");
    } else {
        pythonWidget.setAttribute("collapsed", true);
    }

    var tclInfoSvc = Components.classes['@activestate.com/koTclInfoEx;1'].
                     getService(Components.interfaces.koIAppInfoEx);
    var tclWidget = document.getElementById("menu_helpTclRef_Local");
    var tclHelpFile = tclInfoSvc.localHelpFile;
    if (tclHelpFile) {
        tclWidget.removeAttribute("collapsed");
    } else {
        tclWidget.setAttribute("collapsed", true);
    }
}


function func_helpAbout() {
  openWindowUniqueInstance("chrome://komodo/content/about.xul", 
                           "komodo_about",
                           "chrome,dialog,modal"); 
}

function func_helpLanguage() {
    // Get language
    var language = view.py_inst.sourceFile.getLanguageBlockAtPosition(0).language.name;
    var command, name;
    // Get preference for that language
    if (prefs.hasStringPref(language+'HelpCommand')) {
        command = prefs.getStringPref(language+'HelpCommand');
        if (command == '') {
            command = prefs.getStringPref('DefaultHelpCommand');
        }
        name = language + " Help";
    } else {
        // it's a language we don't have a lookup mechanism defined even in the default prefs
        command = prefs.getStringPref('DefaultHelpCommand');
        name = "Help";
    }
    Run_RunCommand(window,
                   command,
                   null, // cwd
                   null, // env 
                   false, // insertOutput
                   false, // operateOnSelection
                   true, // doNotOpenOutputWindow
                   'no-console', // runIn
                   0, // parseOutput
                   '', // parseRegex
                   0, // showParsedOutputList
                   name); // name
}

function func_helpLanguageAlternate() {
    var command = prefs.getStringPref('OtherHelpCommand');
    Run_RunCommand(window,
                   command,
                   null, // cwd
                   null, // env 
                   false, // insertOutput
                   false, // operateOnSelection
                   true, // doNotOpenOutputWindow
                   'no-console', // runIn
                   0, // parseOutput
                   '', // parseRegex
                   0, // showParsedOutputList
                   "Alternate Help"); // name
}

function func_helpActiveState() {
  OpenUrlInDefaultBrowser("http://www.ActiveState.com/")
}

function func_helpASPN() {
  OpenUrlInDefaultBrowser("http://aspn.ActiveState.com/aspn/")
}

function func_helpSupport() {
  OpenUrlInDefaultBrowser("http://www.ActiveState.com/Support/index.html")
}

function func_helpUpdates() {
  OpenUrlInDefaultBrowser("http://aspn.ActiveState.com/ASPN/Downloads/")
}

function func_helpViewBugs() {
  OpenUrlInDefaultBrowser("http://bugs.ActiveState.com/Komodo/")
}

/*
	function func_helpSubmitBug() {
  // get Komodo information to send to bug submission form
  var infoSvc = Components.classes["@activestate.com/koInfoService;1"].
    getService(Components.interfaces.koIInfoService);
  var tagString = "?buildno=" + infoSvc.buildNumber + "&version=" + infoSvc.version;
  // open in default browser
  OpenUrlInDefaultBrowser("http://bugs.ActiveState.com/Komodo/mksubmit.cgi")
}
*/


//---- Logging stuff

var _koIsDebugBuildFlag = -1 // -1 == "don't know yet"

function koIsDebugBuild() {
    if (_koIsDebugBuildFlag==-1) {
        var infoSvc = Components.classes["@activestate.com/koInfoService;1"].
            getService();
        _koIsDebugBuildFlag = infoSvc.buildType == "debug";
    }
    return _koIsDebugBuildFlag;
}

function _doLog(prefix, message, category, dumpStack) {
  try {
    if (category == undefined)
        category = "";
    if (prefix && category)
        prefix = prefix + "/";
    // The real caller is 2 levels back - the public "logError/Warn/etc" functions, then the real caller.
    var stack = Components.stack.caller.caller;

    // for debug builds, only write it to one place, as they are both the same anyway!
    if (!koIsDebugBuild()) {
        var console = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
        var m = Components.classes["@activestate.com/koConsoleMessage;1"].createInstance(Components.interfaces.nsIScriptError);
        m.init(message, stack.filename, '', stack.lineNumber, 1, Components.interfaces.nsIScriptError.warningFlag, category );
        console.logMessage(m);
    }
  } catch (e) {
      dump("Error writing '" + message + "' to console: " + e + "\n");
  }
  try {
    dump("** " + prefix + category + ": " + message + " at " + stack.filename + '(' + stack.name + '):' + stack.lineNumber + '\n');
    if (dumpStack) {
        stack = stack.caller
        while (stack) {
            dump("--> Called by " + stack.filename + '(' + stack.name + '):' + stack.lineNumber + '\n');
            stack = stack.caller
        }
        dump("-- end of stack trace.\n");
    }
  } catch (e) {
      dump("Error dumping '" + message + "': " + e + "\n");
  }
}

function logWarning(message, category /* = "" */) {
    _doLog("Warning", message, category);
}

function logDebug(message, category /* = "" */) {
    _doLog("", message, category);
}

function logError(message, category /* = "" */) {
    _doLog("ERROR", message, category, true);
}

function LocalFileToURL(localFileName) {
  // Create an nsILocalFile
  var localFile = Components.classes["@mozilla.org/file/local;1"].
    createInstance().QueryInterface(Components.interfaces.nsILocalFile);
  localFile.initWithPath(localFileName);
  // Create a standard URL, but we QI for the FileURL interface!

  var url = Components.classes["@mozilla.org/network/standard-url;1"].
    createInstance().QueryInterface(Components.interfaces.nsIFileURL);
  // Setting the "file" attribute causes initialization...
  url.file = localFile;
  // Meaning we can reference the "spec" attribute holding the URL

  return url.spec;
}

function URLToLocalFile(url_string) {
  // This test is uber-important -- if one does the rest of the code passing in url_string == undefined, one gets a major crash.
  if (typeof(url_string) != 'string') {
      logError("URLToLocalFile called with a non-string argument!");
      throw Components.results.NS_ERROR_UNEXPECTED;
  }
  // Create a file URL.
  var url = Components.classes["@mozilla.org/network/standard-url;1"].
    createInstance().QueryInterface(Components.interfaces.nsIFileURL);
  // Setting the spec means we can access the path!
  url.spec = url_string;
  return url.file;
}

function fileSpecFromURL(url_string) {
  var fileSpec = Components.classes["@activestate.com/koFileSpec;1"]
                 .createInstance(Components.interfaces.koIFileSpec);
  fileSpec.url = url_string; 
  return fileSpec;
}

function fileSpecFromPath(path_string) {
  var fileSpec = Components.classes["@activestate.com/koFileSpec;1"]
                 .createInstance(Components.interfaces.koIFileSpec);
  fileSpec.path = path_string;
  return fileSpec; 
}

function getService(contractId, intf){
    var clz = Components.classes[contractId]
    var iface = Components.interfaces[intf]
    var servc = clz.getService( iface )
    return servc
}

// function openWindowUniqueInstance(chromeURL, windowType, options, *args)
// Open a window if no windows of windowType exist. Otherwise, bring
// the window of windowType to the front. Parameters for this function
// are identical to window.openDialog()

// komodoWindowType stores window types that have been opened, so when
// komodo is closed, it can first close all the windows it has opened.
var openedWindowTypes = new Object();

function openWindowUniqueInstance(chromeURL, windowType, options) {
  const nsIWindowMediator = Components.interfaces.nsIWindowMediator;
  const MEDIATOR_CONTRACTID =
    "@mozilla.org/rdf/datasource;1?name=window-mediator";
  var windowManager =
    Components.classes[MEDIATOR_CONTRACTID].getService(nsIWindowMediator);
  var existingWindow = windowManager.getMostRecentWindow(windowType);
  openedWindowTypes[windowType]=1;
  if (existingWindow) {
    existingWindow.focus();
    return existingWindow;
  } else {
    // Convert arguments into an array for use with apply(), and substitute 
    // '_blank' for windowType to avoid weird Mozilla crashes
    var newArgs = new Array();
    for (var i = 0; i < arguments.length; i++) {
      if (i == 1) {
        newArgs[i] = '_blank';
      } else {
        newArgs[i] = arguments[i];
      } 
    }

    // We'd like to focus this, too, to avoid the z-order problem
    // but this will crash for modal windows. Perhaps we could
    // grep through the options to determine modality?
    return window.openDialog.apply(window, newArgs);
  }
}


// function openWindowMultipleInstance(chromeURL, windowType, options, *args)
// Open a new window, regardless of existing windows. Use this instead of
// window.openDialog(). Parameters are identical to window.openDialog()
function openWindowMultipleInstance(chromeURL, windowType, options) {
  openedWindowTypes[windowType]=1;
  // Convert arguments into an array for use with apply(), and substitute 
  // '_blank' for windowType to avoid weird Mozilla crashes
  var newArgs = new Array();
  for (var i = 0; i < arguments.length; i++) {
    if (i == 1) {
      newArgs[i] = '_blank';
    } else {
      newArgs[i] = arguments[i];
    } 
  }
  return window.openDialog.apply(window, newArgs);
}

function addStyle(cell, aName, aValue) {
  var oldStyle;
  var newStyle;
  try {
    oldStyle = cell.getAttribute('style');
  } catch(e) {
    oldStyle = "";
  }
  if (oldStyle) {
    var foundIt = false;
    var a = oldStyle.split(";");
    for (i in a) {
      if (a[i].indexOf(aName + ":") == 0) {
        // Can't use substr as an l-value unfortunately
        a[i] = aName + ":" + aValue;
        foundIt = true;
      }
    }
    newStyle = a.join(";");
    if (!foundIt)
      newStyle += ";" + aName + ":" + aValue;
  } else {
    newStyle = aName + ":" + aValue;
  }
  cell.setAttribute('style', newStyle);
}

function buildEncodingHierarchy(hierarchy, toplevel, action)  {
    var menu;
    var menupopup;
    var menuitem;
    var children = new Object();
    var count = new Object();
    var i;

    if (hierarchy.container == true)  {
        // build menu
        menupopup = document.createElementNS(XUL_NS, 'menupopup');
        hierarchy.getChildren(children, count);
        children = children.value;

        for (i=0;i<children.length;i++)  {
            menupopup.appendChild(buildEncodingHierarchy(children[i], false, action));
        }
        if (!toplevel)  {
            menu = document.createElementNS(XUL_NS, 'menu');
            menu.setAttribute('label', hierarchy.name);
            menu.setAttribute('class', "subLevel");
            menu.appendChild(menupopup);
            return menu;
        }
        return menupopup;
    }
    else  {
        var obj = hierarchy.item_object;
        menuitem = document.createElementNS(XUL_NS, 'menuitem');
        menuitem.setAttribute('data', obj.python_encoding_name);
        menuitem.setAttribute('label', hierarchy.name);
        menuitem.setAttribute('oncommand', action);
        return menuitem;
    }
}

function _repeatStr(str, aCount) {
   var res = "";
   while (--aCount >= 0)
     res += str;
   return res;
}

function SetBusyCursor(window, enable)
{
  // We could alternatively use the 'wait' property
  if (enable) {
	window.setCursor("spinning");
  } else {
	window.setCursor("auto");
  }
  var numFrames = window.frames.length;
  for(var i = 0; i < numFrames; i++)  {
	SetBusyCursor(window.frames[i], enable);
  }
}


function simpleEnumeratorToArray(enumerator, iid) {
  var result = [];
  while (enumerator.hasMoreElements()) {
      result.push(enumerator.getNext().QueryInterface(iid));
  }
  return result;
}

function koDumpDOM(node, level) {
  if (level == undefined) {
    level = 0
  }
  
  dump(_repeatStr(" ", 2*level) + "<" + node.nodeName + "\n");
  var i;
  for (i = 0; i < node.attributes.length; i++) {
    dump(_repeatStr(" ", (2*level) + 4) + node.attributes[i].nodeName + "='" + node.attributes[i].nodeValue + "'\n");
  }
  if (node.childNodes.length == 0) {
    dump(_repeatStr(" ", (2*level)) + "/>\n");
  } else {
    dump(_repeatStr(" ", (2*level)) + ">\n");
    for (i = 0; i < node.childNodes.length; i++) {
      koDumpDOM(node.childNodes[i], level + 1);
    }
    dump(_repeatStr(" ", 2*level) + "</" + node.nodeName + ">\n");
  }
}

function getNSErrorName(exception) {
  var name = null;
  if (exception instanceof Components.interfaces.nsIXPCException) {
    if (exception.name) {
      name = exception.name;
    } else {
      // determine the name from exception.result (this is for handling
      // nsErrors not specified in 
      // http://lxr.mozilla.org/seamonkey/source/js/src/xpconnect/src/xpc.msg
      switch (exception.result) {
      case 2152857609:
	name = "NS_ERROR_INVALID_PATH";
        break;
      case 2152857611:
        name = "NS_ERROR_FILE_CORRUPTED";
        break;
      case 2152857618:
	name = "NS_ERROR_NOT_FOUND";
	break;
      }
    }
  }
  return name;
}

// indent a string by depth characters using ch (space by default)
// lines containing only whitespace are not modified
// this function assumes lines are terminated with '\n' only
function indentString(str, depth, ch /* = ' ' */) {
  var result;

  // no point in working if there is no indenting to do
  if (depth) {
    if (!ch) ch = ' ';

    var lines = str.split('\n');
    var indentation = '';
   
    var i;
    for (i = 0; i < depth; i++) {
      indentation += ch;
    }
    for (i = 0; i < lines.length; i++) {
      if (!lines[i].match(/^\s*$/)) {
        lines[i] = indentation + lines[i];
      }
    }
    result = lines.join('\n');
  } else {
    result = str;
  }

  return result;
}


// depth = 0 means expand entire object
// note: this will run forever if your object contains cycles!     
// depth = 1 means don't expand anything
// anything else: expand at most depth levels
// Note: using this on some XPCOM objects can crash Mozilla!
function flattenJSObject(ob, depth /* = 0 */) {
  if (!depth) depth = 0;

  var source;
  switch (typeof ob) {
  case 'undefined':
    source = 'undefined';
    break;
  case 'number':
    source = ob.toString();
    break;
  case 'string':
    source = "'" + ob + "'";
    break;
  case 'function':
    source = '[function]';
    break;
  case 'boolean':
    source = ob ? 'true' : 'false';
    break;
  case 'object':
    if (ob == null) {
      source = 'null';
    } else {
      if (depth == 1) {
        source = '[object]';
      } else {
        var properties = '';
        for (var subob in ob) {
          var subsource = flattenJSObject(ob[subob], depth ? (depth - 1) : 0);
          properties += subob + ": " + subsource + ",\n";
        }
        properties = properties.slice(0, -2); // drop the extra ",\n"
        source = "{\n" + indentString(properties, 2) + "\n}";
      }
    }
    break;
  default:
    source = 'unknown object type';
  }
  return source;
}

function test_flattenJSObject() {
  dump("Test 1: flattenJSObject(): ");
  dump(((flattenJSObject() == 'undefined') ? 'pass' : 'fail') + "\n");
  dump("Test 2: flattenJSObject(null): ");
  dump(((flattenJSObject(null) == 'null') ? 'pass' : 'fail') + "\n");
  dump("Test 3: flattenJSObject(45): ");
  dump(((flattenJSObject(45) == '45') ? 'pass' : 'fail') + "\n");
  dump("Test 4: flattenJSObject('string'): ");
  dump(((flattenJSObject('string') == "'string'") ? 'pass' : 'fail') + "\n");
  dump("Test 5: flattenJSObject(true): ");
  dump(((flattenJSObject(true) == 'true') ? 'pass' : 'fail') + "\n");
  dump("Test 6: flattenJSObject(false): ");
  dump(((flattenJSObject(false) == 'false') ? 'pass' : 'fail') + "\n");
}


var myPerfTimer = {};
var perfLog = 0;
function perfTimer(name, title, reset)
{
    if (! perfLog) {
        perfLog = getLoggingMgr().getLogger('perf');
    }
    if (typeof reset == 'undefined' || !reset) {
        reset = false;
    }
    var timenow = new Date();
    if (reset || myPerfTimer[name] == 0) myPerfTimer[name] = timenow;
    var timediff = timenow.getTime()-myPerfTimer[name].getTime();
    //dump("[" + name + ":"+title+"] = "+timediff + " ms\n");
    perfLog.info("[" + name + ":"+title+"] = "+timediff + " ms");
    myPerfTimer[name] = timenow;
}


// open the given url or complain appropriately
function OpenUrlInDefaultBrowser(url) {
    var koWebbrowser = Components.classes['@activestate.com/koWebbrowser;1'].
                   getService(Components.interfaces.koIWebbrowser);
    var browser = prefs.getStringPref('browser');

    var infoService = Components.classes['@activestate.com/koInfoService;1'].
                      getService(Components.interfaces.koIInfoService);
    if (!infoService.platform.match(/^win/) && browser == '') {
        // Don't guess, since launching e.g. Mozilla can have side effects
        var browsers = koWebbrowser.get_possible_browsers(new Object()); 
        var obj = new Object;
        obj.title = "Default Browser Dialog";
        obj.prompt = "Pick the browser that Komodo should use";
        obj.paths = browsers;
        openWindowUniqueInstance('chrome://komodo/content/pickbrowser.xul',
                                                    "komodo_browser_pick",
                                                    "chrome,dialog,modal=yes",
                                                    obj);
        if (! obj.ret) { 
            return;
        }
        prefs.setStringPref('browser', obj.path);
    }
    
    if (! koWebbrowser.open_new(url)) {
        alert("Could not file a graphical browser on the PATH with which " +
              "to open '" + url + "'.");
    }
}

/* ---- UI Helpers for showing/hiding, expanding collapsing, various UI features ---- */

// Shows/Hides toolbars
function toggleToolboxItem( id, fromPrefs, toggleValue )  {

    var elementID;
    var prefName;
    // [commandid, prefName]
    var editMap = ["cmd_viewedittoolbar", "showStandardToolbar"];
    var debugMap = ["cmd_viewdebugtoolbar", "showDebugToolbar"];



    if (id == "editorToolbar") {
        elementID = editMap[0];
        prefName = editMap[1];
    }
    else if (id == "debuggerToolbar") {
        elementID = debugMap[0];
        prefName = debugMap[1];
    }






    var toolbar = document.getElementById( id );
    var element = document.getElementById( elementID );
    if ( toolbar )
    { 
      if ( toggleValue )
      {
        toolbar.setAttribute("hidden", "false" );
        if ( element )
          element.setAttribute("checked","true");
      }
      else
      {
        toolbar.setAttribute("hidden", true );
        if ( element )
          element.setAttribute("checked","false");
      }

      // Use our own prefs instead of moz persistence mechanism
      // Only set if this is set outside the toggling takes *not* from prefs panel
      if (!fromPrefs)  {
          prefs.setBooleanPref(prefName, toggleValue);
      }
    }

}

// button_text_is_showing() - Helper funciton for toggleButtons().
function button_text_is_showing() {
  var istext = prefs.getBooleanPref("showTextButtons");
  if (istext)
	return true;
  else
    return false;
}

// Toggle the text on toolbar buttons
function toggleButtons(show, startup)  {

    // Mmm, do we want to do the Help buttons too for consistency?

    //var newBtn = document.getElementById('newButton');
    var rxBtn = document.getElementById('buttondbgRx');
    var EditBar = document.getElementById('editorToolbar');
    var DebugBar = document.getElementById('debuggerToolbar');



    var menuItem = document.getElementById('menu_toggleButtonText');
    var contextMenuItem = document.getElementById('menu_toggleButtonText');
    var ebuttons, dbuttons, sccbuttons;

    if (show == null)  {  // from the menus
      show = !button_text_is_showing();
      // Set the pref if it is coming from menu commands
      prefs.setBooleanPref('showTextButtons', show);
    }
    if (startup) {
      show = button_text_is_showing();
    }

    var i;
    if (show) {
        ebuttons = EditBar.getElementsByTagName('toolbarbutton');
        for (i=0;i<ebuttons.length;i++) {
          if (ebuttons[i].id != rxBtn.id)
            ebuttons[i].removeAttribute('type');
        }
        dbuttons = DebugBar.getElementsByTagName('toolbarbutton');
        for (i=0;i<dbuttons.length;i++)
          dbuttons[i].removeAttribute('type');





        // Rx button - class="button-toolbar-c"
        rxBtn.setAttribute('class', 'button-toolbar-c');
        
        menuItem.setAttribute('checked', 'true');
        contextMenuItem.setAttribute('checked', 'true');
    }
    else {
        ebuttons = EditBar.getElementsByTagName('toolbarbutton');
        for (i=0;i<ebuttons.length;i++) {
          if (ebuttons[i].id != rxBtn.id)
            ebuttons[i].setAttribute('type', 'image-only');
        }
        dbuttons = DebugBar.getElementsByTagName('toolbarbutton');
        for (i=0;i<dbuttons.length;i++)
          dbuttons[i].setAttribute('type', 'image-only');





        // Rx button - class="button-toolbar-c"
        rxBtn.setAttribute('class', 'button-toolbar-d');
        
        menuItem.setAttribute('checked', 'false');
        contextMenuItem.setAttribute('checked', 'false');		
    }

    document.persist(menuItem, 'checked');
}

// Taken from Mozilla's Sidebar code...
function expandCollapseSplitter(splitterId, menuId) {
    var koSplitter = document.getElementById(splitterId);
    var koMenuitem = document.getElementById(menuId);

    if (koSplitter.getAttribute('state') == 'collapsed') {
        koSplitter.removeAttribute('state');
        koMenuitem.setAttribute('checked', 'true');
    } else {
        koSplitter.setAttribute('state', 'collapsed');
        koMenuitem.setAttribute('checked', 'false');
    }
}

// Helper for when splitter grippy is clicked on and splitter dragged
function SplitterClick(menuId, boxId)  {
    setTimeout("isBoxCollapsed('"+menuId+"', '"+boxId+"')", 10);
}

function isBoxCollapsed(menuId, boxId)  {
    var is_collapsed = document.getElementById(boxId).getAttribute('collapsed') == 'true' ? true : false;
    if (is_collapsed)
        document.getElementById(menuId).setAttribute('checked', 'false');
    else
        document.getElementById(menuId).setAttribute('checked', 'true');
}

function expandCollapseToolbar(toolboxId, toolbarId) {
    var koToolbox = document.getElementById(toolboxId);
    var koToolbar = document.getElementById(toolbarId);

    var x = "moz_tb_collapsed_" + koToolbar.id;

    if(document.getElementById(x))
    {
        koToolbox.expandToolbar(x);
    }
    else
    {
        koToolbox.collapseToolbar(koToolbar);
    }
}

/* ---- Event queue and IDLE management ---- */

// Process all pending events in the event queue.  This will do things like 
// force reflow events, etc.
function koProcessPendingEvents() {
    var nsIEventQueueService = Components.interfaces.nsIEventQueueService;
    var CID = Components.classes["@mozilla.org/event-queue-service;1"];
    var service = CID.getService(nsIEventQueueService);
    service.createThreadEventQueue();
    var q = service.getSpecialEventQueue(nsIEventQueueService.CURRENT_THREAD_EVENT_QUEUE);
    q.processPendingEvents();
}

function doGlobalPrefs(panel)  {
    var oldlanguage = prefs.getStringPref("fileDefaultNew");
    
    // Handle cancel from prefs window
    var resp = new Object ();
    resp.res = "";    
    try {    
        openWindowUniqueInstance("chrome://komodo/content/pref/pref.xul", 
                'komodo_prefs',
                "chrome,titlebar,modal=yes,resizable=yes",panel, resp);
    }
    catch(e) {
        logDebug("Failed to open global preferences dialog");
        return false;
    } 
    if (resp.res != "ok") {
        return false;
    }                      
    // And ensure any state changes are reflected in the menus, toolbars, etc
    koRequestUpdateCommands("buffer-focus");
    koRequestUpdateCommands("buffer-visible");
    // update the "new file" menus with the designated hitter for ctrl-n
    /*var newlanguage = prefs.getStringPref("fileDefaultNew");
    if (oldlanguage != newlanguage) {
	var olditem = document.getElementById("menu_new"+oldlanguage);
	var olditem2 = document.getElementById("menu_new"+oldlanguage+'2');
	olditem.setAttribute("key", "");
	olditem2.setAttribute("key", "");
	var newitem = document.getElementById("menu_new"+newlanguage);
	var newitem2 = document.getElementById("menu_new"+newlanguage+'2');
	newitem.setAttribute("key", "key_newDefault");
	newitem2.setAttribute("key", "key_newDefault");
    }*/
    return true;
}

function doFilePrefs(tab)  {
      // ensure the current view's prefs are up-to-date
      var view = getFocusedViewManager();
      var resp = new Object ();
      resp.res = "";
      if (!tab)
          tab = "settings";
          
      openWindowUniqueInstance("chrome://komodo/content/editor/currentViewPrefs.xul", 
                               'komodo_viewprefs',
                               "chrome,resizable,scrollbars,dialog=yes,close,modal=yes",
                               resp, view, tab);
      
      if (resp.res != "ok") {
          return false;
      }
      // And ensure any state changes are reflected in the menus, toolbars, etc
      koRequestUpdateCommands("buffer-focus");
      koRequestUpdateCommands("buffer-visible");
      
      return true;
}    

function doMacro(macroName) {
	var macro = prefs.getStringPref(macroName);
	var v = viewManager.getCurrentView();
	if (!v || !macro) {
		return;
	}
	var filename = URLToLocalFile(v.url).path;
	var action = macro.replace('$filename', filename);
	var retval = os.system(action);
	if (! retval) { alert("Macro failed performing: " + action); }
	else { alert("Macro Succeeded:" + action); }

}

function gotoCookbooks()  {
    OpenUrlInDefaultBrowser("http://ASPN.ActiveState.com/ASPN/Cookbook/")
}

function ASPNAuthenticate()  {
    var cookie, validated, retval;
    var ASPNService = Components.classes['@activestate.com/koASPNService;1'].getService(Components.interfaces.koIASPNService);

// The following would allow 'persistence during the session'.  Not sure if it's a good idea or not.
//    if (ASPNService.authenticated) {
//        return true;
//    }
    if (globalPrefs.hasStringPref('ASPNCookie')) {
        cookie = globalPrefs.getStringPref('ASPNCookie');
        if (cookie && ASPNService.authenticate_with_cookie(cookie)) {
            return true;
        } // If this fails, get rid of the cookie and move on.
    }
    retval = 1;
    while (1) {
        if (retval == "Cancel")  { 
            return false;
        } else { //  User is trying to login
            var ASPN = authDialog(gKomodoBundle.getString("aspnLogin_header"), gKomodoBundle.getString("aspnLogin_message"));
            if (! ASPN.retval) { // User pressed cancel 
                return false;
            }
            validated = ASPNService.login(ASPN.user, ASPN.pwd);
            if (validated) {
                if (ASPN.persist) {
                    globalPrefs.setStringPref('ASPNCookie', ASPNService.cookie);
                }
                return true;
            } else {
                retval = alertDialog("ASPN Login Failed", false, false, "Try Again", "Cancel");
            }
        }
    }
    return false;
}

function submitRecipe()  {
    var sci_widget = document.getElementById("scin");
    var scimoz = sci_widget.ISciMoz;
    var recipe = scimoz.selText;
    if (recipe == "")  {
        alertDialog("Please select some code to submit and try again.");
        return;
    }

    var validUser = ASPNAuthenticate();
    if (validUser)  {
        var view = getFocusedViewManager().getCurrentView();
        var ASPNService = Components.classes['@activestate.com/koASPNService;1'].getService(Components.interfaces.koIASPNService);
        try {    
            openWindowUniqueInstance("chrome://komodo/content/cookbook/cookbook.xul", 
                    'komodo_cookbook',
                    "chrome,dialog,modal",
                    ASPNService.cookie, recipe, view);
        }
        catch(e) {
            logDebug("Failed to open cookbook dialog: " + e);
            return;
        }
    }
}

function mk_wsundelpoy_menu(popupid)
{
        var deployService = Components.classes['@activestate.com/koWSDeploymentService;1'].getService(Components.interfaces.koIWSDeploymentService);
	var popup = document.getElementById(popupid);
	var prefs= Components.classes["@activestate.com/koPrefService;1"].getService(Components.interfaces.koIPrefService).prefs;
	var host = prefs.getStringPref('PerlExHost');
	var port = prefs.getLongPref('PerlExPort');
	alert(deployService.getServices(host, port));
}	

function undeployWebService(wsname) {
	alert("undeploying " + wsname);
}	


/**********************************
  repeatable buttons
  call startButtonRepeater with the onmousedown event
 You must pass a function to startButtonRepeater that will handle the action for the button
 being held down
 XXX tried to do the genericly, but js doesn't track the widget correctly :(
*/

var delayButtonRepeaterTimer = null;
var currentButtonRepeater = null;
var editorTabWidget = null;
var buttonRepeaterDirection = null;
function startButtonRepeater(direction) {
    if (!editorTabWidget) {
        editorTabWidget = document.getElementById("tabbox");
    }
    if (delayButtonRepeaterTimer) {
        // kill the current intervall
        window.clearTimeout(delayButtonRepeaterTimer);
    }
    buttonRepeaterDirection = direction;
    delayButtonRepeaterTimer = window.setTimeout('realyStartButtonRepeater()',500);
}

function realyStartButtonRepeater() {
    delayButtonRepeaterTimer = null;
    if (currentButtonRepeater) {
        // kill the current intervall
        stopButtonRepeater();
    }
    currentButtonRepeater = window.setInterval('doButtonRepeater()',100);
}

function stopButtonRepeater() {
    if (delayButtonRepeaterTimer) {
        doButtonRepeater(); // probably a single click, move it a bit!
        window.clearTimeout(delayButtonRepeaterTimer);
    }
    if (currentButtonRepeater) window.clearInterval(currentButtonRepeater);
    currentButtonRepeater = null;
    buttonRepeaterDirection = null;
    delayButtonRepeaterTimer = null;
}

function doButtonRepeater() {
   if (buttonRepeaterDirection==0) {
       editorTabWidget.scrollLeft();
   } else {
       editorTabWidget.scrollRight();
   }
}


function getStackTrace ()
{

    if (!((typeof Components == "object") &&
          (typeof Components.classes == "object")))
        return "No stack trace available.";

    var frame = Components.stack.caller;
    var str = "<top>";

    while (frame)
    {
        var name = frame.name ? frame.name : "[anonymous]";
        str += "\n" + name + "@" + frame.filename +':' + frame.lineNumber;
        frame = frame.caller;
    }

    return str+"\n";
    
}


