/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

var globalPrefs = Components.classes['@activestate.com/koPrefService;1'].getService().
    QueryInterface(Components.interfaces.koIPrefService).prefs;

var ASPNService = Components.classes['@activestate.com/koASPNService;1'].getService().QueryInterface(Components.interfaces.koIASPNService);

var gPaths, gListOutliner;

/***
Note that the pref dialogs use a *copy* of the global prefs.

If the user selects "Clear", then selects "Cancel", we *do* want the password
to remain cleared.

Therefore, we update *both* the global preference set, and the prefset
the pref dialog is currently using.

**/
function PrefASPN_OnLoad()
{
    var tag = 'chrome://komodo/content/pref/pref-ui.xul';
    parent.hPrefWindow.onpageload(tag);
    var clearASPN = document.getElementById('clearASPN');
    var localPrefs = top.hPrefWindow._getCurrentPrefSet();
    if ((globalPrefs.hasStringPref('ASPNCookie') && globalPrefs.getStringPref('ASPNCookie') != '') ||
        (localPrefs.hasStringPref('ASPNCookie') && localPrefs.getStringPref('ASPNCookie') != '')) {
        clearASPN.setAttribute('disabled', 'false');
    } else {
        clearASPN.setAttribute('disabled', 'true');
    }
    var koWebbrowser = Components.classes['@activestate.com/koWebbrowser;1'].
                   getService(Components.interfaces.koIWebbrowser);
    gPaths = koWebbrowser.get_possible_browsers(new Object()); 
    gListOutliner = document.getElementById('file-outliner');
    gListOutliner.outlinerBoxObject.view=gListOutlinerView;
    gListOutlinerView.setRowCount(gPaths.length);
    gListOutliner.focus();
}

function clearASPNPref() {
    var localPrefs = top.hPrefWindow._getCurrentPrefSet();
    localPrefs.setStringPref("ASPNCookie", '');
    globalPrefs.setStringPref("ASPNCookie", '');
    var clearASPN = document.getElementById('clearASPN');
    clearASPN.setAttribute('disabled', 'true');
    ASPNService.logout();
}

function browseForBrowser() {
    var path;
    var fp = dlg_openExeFile();
    if (fp == null) {
        return null;
    }
    path = fp.file.path;
    path = path.replace('"', '\\"', 'g');
    if (path.indexOf(' ') != -1) {
        path = '\"' + path + '\"';
    }
    document.getElementById('browser').setAttribute('value', path);
    return null;
}


var gListOutlinerView= {
    // We access global data.  heck, it's a dialog, it won't last.
    getCellText : function(row,column){ if (typeof(gPaths) != 'undefined') return gPaths[row]; else return '';},
    // Everything below here is just to satisfy the interface, and not all of it may
    // be required.

    rowCount : 0,
    outliner : null,
    isSeparator : function(index) {return false;},
    isContainer : function(index) {return false;},
    setOutliner : function(out) { this.outliner = out; },
    getRowProperties : function(row,prop){},
    getColumnProperties : function(column,prop){},
    getCellProperties : function(row,prop){},
    isContainer : function(row) {return false;},
    cycleCell: function(row, colId) {},
    setRowCount : function(rowCount) {
        this.rowCount = rowCount;
        this.outliner.rowCountChanged(0, this.rowCount);
        this.outliner.invalidate();
    },
    selectionChanged : function() {},
    performAction : function(action) {},
    
    /* our own defined methods */
    sort: function() {
    }    
};

function OnClick(e) {
    var t = e.originalTarget;
    if (t.localName != "outlinerbody")
        return;
    var pickedPath = '';
    for (var i =0; i < gPaths.length; i++) {
        if (gListOutlinerView.selection.isSelected(i)) {
            pickedPath = gPaths[i];
            break;
        }
    }
    pickedPath = pickedPath.replace('\"', '\\\"', 'g');
    if (pickedPath.indexOf(' ') != -1) {
        pickedPath = '"' + pickedPath + '"';
    }
    document.getElementById('browser').setAttribute('value', pickedPath);
}
