/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

//---- globals
var _findingInterps = false;
var availInterps = [];
//---- functions
var phpAppInfoEx = null;

/* Functions Related to pref-phpini.xul */
function PrefPhp_OnLoad()  {
    var tag = 'chrome://komodo/content/pref/pref-php.xul';
    parent.hPrefWindow.onpageload(tag);
    parent.hPrefWindow.registerOKCallbackFunc(PrefPhp_OkCallback, tag);
    // find the available PHP interps
    phpAppInfoEx = Components.classes["@activestate.com/koPHPInfoInstance;1"].
            createInstance(Components.interfaces.koIPHPInfoEx);
    PrefPhp_PopulatePHPInterps();
    PrefPhp_DebuggerConfiguredMessage();
}

function _warnIni()
{
    // XXX I'll come back to this later.  Shane
    //dump("_warnIni\n");
    //var txt = document.getElementById('iniExplain');
    //var text = "WARNING: Changing the executable may require changing your INI path.";
    //if (txt.childNodes.length > 0) {
    //    txt.removeChild(txt.childNodes[0]);
    //}
    //txt.appendChild(document.createTextNode(text));
}

function PrefPhp_DebuggerConfiguredMessage()
{
    var txt = document.getElementById('debugger-configured-msg');
    var ini = document.getElementById('phpConfigFile').value;
    var interpreter = document.getElementById('phpDefaultInterpreter').value;
    if (!interpreter && availInterps.length > 0) {
        interpreter = availInterps[0];
    }

    phpAppInfoEx.executablePath = interpreter;
    phpAppInfoEx.cfg_file_path = ini;
    var text;
    if (phpAppInfoEx.isDebuggerExtensionLoadable) {
        text = "PHP is configured for debugging.  You can use the "+
            "configuration wizard to reconfigure if you have changed "+
            "your primary ini file.";
    } else {
        text = "WARNING!  PHP is not configured for debugging.  You can use the "+
            "configuration wizard to configure PHP for debugging.";
    }
    if (txt.childNodes.length > 0) {
        txt.removeChild(txt.childNodes[0]);
    }
    txt.appendChild(document.createTextNode(text));
}

function PrefPhp_OkCallback(prefset)
{
    var ok = true;
    
    // ensure that the default PHP interpreter is valid
    var defaultInterp = prefset.getStringPref("phpDefaultInterpreter");
    if (defaultInterp != "") {
        var koSysUtils = Components.classes["@activestate.com/koSysUtils;1"].
            getService(Components.interfaces.koISysUtils);
        if (! koSysUtils.IsFile(defaultInterp)) {
            parent.opener.alertDialog("No PHP interpreter could be found at '" +
                defaultInterp + "'. You must make another selection for " +
                "the default PHP interpreter.\n");
            ok = false;
            document.getElementById("phpDefaultInterpreter").focus();
        }
    }

    return ok;
}

function PrefPhp_UnSelectInterp()
{
    var tree = document.getElementById("tree-avail-interp-list");
    tree.clearItemSelection();
    _warnIni();
}


function PrefPhp_SelectInterp()
{
    if (! _findingInterps) {
        // Load the default interpeter textfield with the selection
        var tree = document.getElementById("tree-avail-interp-list");
        var defaultInterp = document.getElementById("phpDefaultInterpreter");
        if (tree.selectedItems.length > 0) {
            var selection = tree.selectedItems[0];
            //          treeitem . treerow  . treecell 
            var value = selection.firstChild.firstChild.getAttribute("label");
            defaultInterp.value = value;
            //document.getElementById('phpConfigFile').value = '';
        }
    }
    _warnIni();
    PrefPhp_DebuggerConfiguredMessage();
}

// Populate the (tree) list of available PHP interpreters on the current
// system.
function PrefPhp_PopulatePHPInterps()
{
    var availInterpList = document.getElementById("avail-interp-list");

    // remove any existing items and add a "finding..." one
    _findingInterps = true;
    while (availInterpList.hasChildNodes()) {
        availInterpList.removeChild(availInterpList.childNodes[0]);
    }
    availInterpList.appendChild(_CreatePhpInterpItem(
        "Finding available PHP interpreters..."));
   
    // get a list of installed PHP interpreters
    var numFound = new Object();
    availInterps = phpAppInfoEx.FindInstallationExecutables(numFound);

    // populate the tree listing them
    if (availInterps.length == 0) {
        // tell the user no interpreter was found and direct them to
        // ActiveState to get one
        document.getElementById("avail-interp-box").
            setAttribute("collapsed", "true");
        document.getElementById("no-avail-interps-message").
            setAttribute("collapsed", "false");
    } else {
        availInterpList.removeChild(availInterpList.childNodes[0]); // "Finding..."
        for (var i = 0; i < availInterps.length; i++) {
            availInterpList.appendChild(_CreatePhpInterpItem(
                availInterps[i]));
        }
    }
    _findingInterps = false;
}

function _CreatePhpInterpItem(fname)
{
    var treecell = document.createElementNS(XUL_NS, 'treecell');
    treecell.setAttribute('label', fname);
    var treerow = document.createElementNS(XUL_NS, 'treerow');
    treerow.appendChild(treecell);
    var treeitem = document.createElementNS(XUL_NS, 'treeitem');
    treeitem.appendChild(treerow);
    return treeitem;
}

/* Functions Related to pref-phpini.xul */

function PrefPhpIni_OnLoad()  {
    var tag = 'chrome://komodo/content/pref/pref-phpini.xul';
    parent.initPanel(tag);
    parent.registerOKCallbackFunc(PrefPhpIni_OkCallback, tag);

}

function PrefPhpIni_OkCallback(prefset)
{
    //...
    return true;
}

function PrefPhp_SelectIni() {
    PrefPhp_DebuggerConfiguredMessage();
}

function loadIniFile() {
    var fpOpen = Components.classes["@mozilla.org/filepicker;1"].
    createInstance(Components.interfaces.nsIFilePicker);
    fpOpen.init(window, "Open File", Components.interfaces.nsIFilePicker.modeGetFolder);
    fpOpen.appendFilters(Components.interfaces.nsIFilePicker.filterAll);
    if (fpOpen.show() == Components.interfaces.nsIFilePicker.returnOK) {
        document.getElementById('phpConfigFile').setAttribute('value', fpOpen.file.path)
    }
    PrefPhp_DebuggerConfiguredMessage();
}

function loadPHPExecutable() {
    if (isLinux) {
        filters = [['All Files',['*']]];
    } else {
        filters = [['Executables',['*.exe']]];
    }    
    var php = BrowseForFile(document.getElementById('phpDefaultInterpreter').value, filters)
    if (php != null) {
        document.getElementById('phpDefaultInterpreter').
            setAttribute('value', php);
        _warnIni();
    }
}


function wizardConfigurePHP() {
    // get selected php and ini dirs
    var info = {};
    info.ini = document.getElementById('phpConfigFile').value;
    info.interpreter = document.getElementById('phpDefaultInterpreter').value;
    info.ok = false;
    window.openDialog(
            "chrome://komodo/content/wizards/setup/php/wizard.xul",
            "komodo_wizard",
            "centerscreen,chrome,resizable,scrollbars,dialog=yes,close,modal=yes",
            info);
    if (info.ok) {
        document.getElementById('phpConfigFile').value = info.ini;
        document.getElementById('phpDefaultInterpreter').value = info.interpreter;
        PrefPhp_DebuggerConfiguredMessage();
    }
}