/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

//---- globals
var _findingInterps = false;

// preferences used in the pref window
var _elementIDs = [
//XXX need infrastructure for these in the editor
//    "pythonUseLinting",
//    "pythonUseTooltips"
    "pythonDefaultInterpreter",
];


//---- functions

function PrefPython_OkCallback(prefset)
{
    var ok = true;
    
    // ensure that the default python interpreter is valid
    var defaultInterp = prefset.getStringPref("pythonDefaultInterpreter");
    if (defaultInterp != "") {
        var koSysUtils = Components.classes["@activestate.com/koSysUtils;1"].
            getService(Components.interfaces.koISysUtils);
        if (! koSysUtils.IsFile(defaultInterp)) {
            parent.opener.alertDialog("No Python interpreter could be found at '" +
                defaultInterp + "'. You must make another selection for " +
                "the default Python interpreter.\n");
            ok = false;
            document.getElementById("pythonDefaultInterpreter").focus();
        }
    }

    return ok;
}


function PrefPython_UnSelectInterp()
{
    var tree = document.getElementById("tree-avail-interp-list");
    tree.clearItemSelection();
}


function PrefPython_SelectInterp()
{
    if (! _findingInterps) {
        // Load the default interpeter textfield with the selection
        var tree = document.getElementById("tree-avail-interp-list");
        var defaultInterp = document.getElementById("pythonDefaultInterpreter");
        if (tree.selectedItems.length > 0) {
            var selection = tree.selectedItems[0];
            //          treeitem . treerow  . treecell 
            var value = selection.firstChild.firstChild.getAttribute("label");
            defaultInterp.value = value;
        }
    }
}


function _CreatePythonInterpItem(fname)
{
    var treecell = document.createElementNS(XUL_NS, 'treecell');
    treecell.setAttribute('label', fname);
    var treerow = document.createElementNS(XUL_NS, 'treerow');
    treerow.appendChild(treecell);
    var treeitem = document.createElementNS(XUL_NS, 'treeitem');
    treeitem.appendChild(treerow);
    return treeitem;
}


// Populate the (tree) list of available Python interpreters on the current
// system.
function PrefPython_PopulatePythonInterps()
{
    var availInterpList = document.getElementById("avail-interp-list");
    var defaultInterp = document.getElementById("pythonDefaultInterpreter");

    // remove any existing items and add a "finding..." one
    _findingInterps = true;
    while (availInterpList.hasChildNodes()) {
        availInterpList.removeChild(availInterpList.childNodes[0]);
    }
    availInterpList.appendChild(_CreatePythonInterpItem(
        "Finding available Python interpreters..."));
    
    // get a list of installed Python interpreters
    var sysUtils = Components.classes['@activestate.com/koSysUtils;1'].
        getService(Components.interfaces.koISysUtils);
    var availInterps = new Array();
    availInterps = sysUtils.WhichAll("python", new Object());

    // populate the tree listing them
    if (availInterps.length == 0) {
        // tell the user no interpreter was found and direct them to
        // ActiveState to get one
        document.getElementById("avail-interp-box").
            setAttribute("collapsed", "true");
        document.getElementById("no-avail-interps-message").
            setAttribute("collapsed", "false");
    } else {
        availInterpList.removeChild(availInterpList.childNodes[0]); // "Finding..."
        for (var i = 0; i < availInterps.length; i++) {
            availInterpList.appendChild(_CreatePythonInterpItem(
                availInterps[i]));
        }
    }
    _findingInterps = false;
}


function PrefPython_OnLoad()
{
    var tag = 'chrome://komodo/content/pref/pref-python.xul';
    parent.hPrefWindow.onpageload(tag);
    parent.hPrefWindow.registerOKCallbackFunc(PrefPython_OkCallback, tag); 

    // find the available Python interps (but let window load)
    PrefPython_PopulatePythonInterps();
}

