/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

// start the extension
registeredExtensions[registeredExtensions.length] = new peMacro();

function peMacro() {
}

// The following two lines ensure proper inheritance (see Flanagan, p. 144).
peMacro.prototype.constructor = peMacro;


// XXX lousy place for this.
var gLanguageRegistry = null;

peMacro.prototype.init = function() {
    gLanguageRegistry = Components.classes["@activestate.com/koLanguageRegistryService;1"].
          getService(Components.interfaces.koILanguageRegistryService);
}

peMacro.prototype.registerCommands = function() {
    extensionManager.registerCommand('cmd_addMacro_Project', this);
    extensionManager.registerCommand('cmd_addMacro', this);
    extensionManager.registerCommand('cmd_editMacroProperties', this);
    extensionManager.registerCommand('cmd_editMacro', this);
    extensionManager.registerCommand('cmd_executeMacro', this);
}

peMacro.prototype.registerEventHandlers = function() {
    extensionManager.addEventHandler(Components.interfaces.koIPart_macro,
                                     'ondblclick', this);
    extensionManager.addEventHandler(Components.interfaces.koIPart_macro,
                                     'onUpdatePart', this);
}

peMacro.prototype.registerMenus = function() {
    extensionManager.createMenuItem(Components.interfaces.koIContainer,
                                    'Add New Macro...',
                                    'cmd_addMacro');
    extensionManager.createMenuItem(Components.interfaces.koIPart_macro,
                                    'Execute Macro',
                                    'cmd_executeMacro');
    extensionManager.createMenuItem(Components.interfaces.koIPart_macro,
                                    'Edit Macro',
                                    'cmd_editMacro');
    extensionManager.createMenuItem(Components.interfaces.koIPart_macro,
                                    'Properties', 'cmd_editMacroProperties');
}

peMacro.prototype.ondblclick = function(item,event) {
    if (item.type != 'macro') return;
    _executeMacro(item.part)
}

peMacro.prototype.supportsCommand = function(command, item) {
    switch (command) {
    case 'cmd_addMacro_Project':
        return gProjectManager.getCurrentProject() != null;
    case 'cmd_addMacro':
        return true;
    case 'cmd_executeMacro':
    case 'cmd_editMacro':
    case 'cmd_editMacroProperties':
        var items = gFocusedProjectView.getSelectedItems();
        if (items.length == 1 && items[0].part
            && items[0].part.type == 'macro') {
            return true;
        } else {
            return false;
        }
    default:
        break;
    }
    return false;
}

peMacro.prototype.isCommandEnabled = peMacro.prototype.supportsCommand;

peMacro.prototype._addMacro = function(item)
{
    var part = Components.classes['@activestate.com/koPart?type=macro;1']
               .createInstance(Components.interfaces.koIPart_macro);
    part.setStringAttribute('filename', '');
    part.setStringAttribute('name', 'New Macro');
    var obj = new Object();
    obj.item = new partWrapper(part, 0);
    obj.task = 'new';
    openWindowUniqueInstance(
        "chrome://komodo/content/project/macroProperties.xul", 
        "komodo_macroProperties",
        "chrome,close=yes,modal=yes", obj);
    if (obj.res) {
        var index = -1;
        if (typeof(item)=='undefined' || !item) 
            item = gFocusedProjectView.getSelectedItem();
        if (item) index = gFocusedProjectView.getIndexByPart(item);    
        gFocusedProjectView.manager.addItem(part,index);
    }
}

function makeMacroFromFileItem(item) {
    // converting a file into an macro
    var part = Components.classes['@activestate.com/koPart?type=macro;1']
               .createInstance(Components.interfaces.koIPart_macro);
    var filename = URLToLocalFile(item.url).path;
    part.setStringAttribute('filename', filename);
    part.setStringAttribute('name', 'Macro: ' + os.path.basename(filename));
    var obj = new Object();
    obj.item = new partWrapper(part, 0);
    obj.task = 'new';
    openWindowUniqueInstance(
        "chrome://komodo/content/project/macroProperties.xul", 
        "komodo_macroProperties",
        "chrome,close=yes,modal=yes", obj);
    if (obj.res) {
        toolboxMgr.addItem(part);
    }    
}

function makeMacroFromFile(filename) {
    var part = Components.classes['@activestate.com/koPart?type=macro;1']
               .createInstance(Components.interfaces.koIPart_macro);
    part.setStringAttribute('filename', filename);
    part.setStringAttribute('name', 'Recorded Macro: ' + os.path.basename(filename));
    toolboxMgr.addItem(part);
}

function _executeMacro(part) {
    var fname = part.getStringAttribute('filename');
    var language = gLanguageRegistry.suggestLanguageForFile(fname).toLowerCase();
    var retval = null;
    if (!os.path.exists(fname)) {
        retval = "The file "+fname+" does not exist"
    }
    if (!os.path.isfile(fname)) {
        retval = fname + " is not a file"
    }
    if (retval == null) {
        var view = gLastFocusedViewManager.getCurrentView();
        var editor = null;
        if (view) {
            editor = view._scimoz;
        }
        switch (language) {
            case 'javascript':
                try {
                    MacroEvalCode(os.readfile(fname));
                } catch (e) {
                    retval = String(e);
                }
                break;
            case 'python':
            case 'perl':
                retval = part.evalAs(language, document, window, editor);
                break;
            default:
                retval = "Macros written in '"+language+"' aren't supported."
        }
    }
    if (retval) {
        alertDialog("There was a problem executing the macro: " + part.getStringAttribute('name'),
                    true, true, false , false , retval);
    }
}

function assertMacroVersion(version) {
    // noop for now.
}

function MacroEvalCode(code) {
    var view = gLastFocusedViewManager.getCurrentView();
    var editor = null;
    if (view) {
        editor = view._scimoz;
    }
    eval("\
    var komodo;\
    if (typeof(komodo) == 'undefined') {\
        function _Komodo() {\
            this.window = window.QueryInterface(Components.interfaces.nsIDOMWindowInternal);\
        };\
        _Komodo.prototype.constructor = _Komodo;\
        komodo = new _Komodo();\
    };");
    eval(code);    
}

peMacro.prototype.doCommand = function(command) {
    var cmd = null;
    var item = null;
    switch (command) {
    case 'cmd_addMacro_Project':
        gProjectManager.viewMgr.focus();
        item = gProjectManager.getCurrentProject();
        // fall through
    case 'cmd_addMacro':
        this._addMacro(item);
        break;
    case 'cmd_editMacroProperties':
        item = gFocusedProjectView.getSelectedItem();
        this._macroProperties(item);
        break;
    case 'cmd_executeMacro':
        item = gFocusedProjectView.getSelectedItem();
        _executeMacro(item.part);
        break;
    case 'cmd_editMacro':
        item = gFocusedProjectView.getSelectedItem();
        var filename = item.part.getStringAttribute('filename');
        doFileOpen(LocalFileToURL(filename));
        break;
    default:
        break;
    }
}

peMacro.prototype._macroProperties = function(item)
{
    var obj = new Object();
    obj.item = item;
    obj.task = 'edit';
    openWindowMultipleInstance(
        "chrome://komodo/content/project/macroProperties.xul", 
        "komodo_macroproperties",
        "chrome,close=yes", obj);
}


peMacro.prototype.onUpdatePart = function(item,event)
{
    if (item.type == 'macro') {
        item.renameable = true;
        item.iconstyle['macro'] = 1;
    }
}

function Execute_NamedMacro(name) {
    // this works directly on a part, so the part does not need
    // to be wrapped in order to execute a macro
    var macroPart = toolboxMgr.findPartByTypeAttributeValue('macro','name', name);
    if (!macroPart) {
        macroPart = gProjectManager.findPartByTypeAttributeValue('macro','name', name);
    }
    if (macroPart) {
        _executeMacro(macroPart);
    }
}


