/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

// start the extension
registeredExtensions[registeredExtensions.length] = new peURL();

function peURL() {
}

// The following two lines ensure proper inheritance (see Flanagan, p. 144).
peURL.prototype.constructor = peURL;

peURL.prototype.init = function() {
}

peURL.prototype.registerCommands = function() {
    extensionManager.registerCommand('cmd_openSpecifiedURL', this);
    extensionManager.registerCommand('cmd_addURL', this);
    extensionManager.registerCommand('cmd_editURL', this);
}

peURL.prototype.registerEventHandlers = function() {
    extensionManager.addEventHandler(Components.interfaces.koIPart_URL,'ondblclick',this);
    extensionManager.addEventHandler(Components.interfaces.koIPart_URL, 'onUpdatePart',this);
}

peURL.prototype.registerMenus = function() {
    extensionManager.createMenuItem(Components.interfaces.koIPart_URL, 
                                    'Open URL in browser...','cmd_openSpecifiedURL');
    extensionManager.createMenuItem(Components.interfaces.koIContainer,
                                    'Add URL...', 'cmd_addURL');
    extensionManager.registerCommand('cmd_addURL_Project', this);
    extensionManager.createMenuItem(Components.interfaces.koIPart_URL,
                                    'Properties...', 'cmd_editURL');
}

peURL.prototype.ondblclick = function(part,event) {
    if (part.type != 'URL') return;
    this.openURL(part)
}

peURL.prototype.supportsCommand = function(command, part) {
    var items = gFocusedProjectView.getSelectedItems();
    if (items.length > 1) return false;
    
    var view = gFocusedProjectView;
    if (!view) return false;
    //dump("supportsCommand for " + command +'\n');
    switch (command) {
    case 'cmd_addURL_Project':
        return gProjectManager.getCurrentProject() != null;
    case 'cmd_openSpecifiedURL':
    case 'cmd_addURL':
    case 'cmd_editURL':
        return true;
    default:
        break;
    }
    return false;
}

peURL.prototype.isCommandEnabled = peURL.prototype.supportsCommand;

peURL.prototype.doCommand = function(command) {
    var view, part;
    switch (command) {
    case 'cmd_addURL_Project':
        if (gProjectManager.getCurrentProject() == null) return;
        gProjectManager.viewMgr.focus();
        // fall through
    case 'cmd_addURL':
        this.addURL();
        break;
    case 'cmd_openSpecifiedURL':
        view = gFocusedProjectView;
        part = view.getSelectedItem();
        this.openURL(part);
        break;
    case 'cmd_editURL':
        view = gFocusedProjectView;
        part = view.getSelectedItem();
        this.editURL(part);
        break;
    default:
        break;
    }    
}

peURL.prototype.openURL= function(item) {
    var part = item.part;
    //dump("part = " + part + " type = " + typeof(part) +'\n');
    var URL = part.value;
    //dump("URL = " + URL + ' type = ' + typeof(URL) +'\n');
    try {
        OpenUrlInDefaultBrowser(URL);
    } catch (e) {
        logError(e);
    }
}

peURL.prototype.editURL = function(item) {
    var obj = new Object();
    obj.item = item;
    obj.task = 'edit';
    obj.imgsrc = 'chrome://komodo/skin/images/xlink.gif';
    obj.type = 'url';
    obj.prettytype = 'URL';
    openWindowMultipleInstance(
        "chrome://komodo/content/project/simplePartProperties.xul", 
        "komodo_URLproperties",
        "chrome,close=yes,dependent=yes,resizable=yes", obj);
}

peURL.prototype.addURL = function() {
    var part = Components.classes['@activestate.com/koPart?type=URL;1']
               .createInstance(Components.interfaces.koIPart_URL);
    part.setStringAttribute('name', 'New URL');
    part.value = '';
    var obj = new Object();
    obj.item = new partWrapper(part, 0);
    obj.task = 'new';
    obj.imgsrc = 'chrome://komodo/skin/images/xlink.gif';
    obj.type = 'url';
    obj.prettytype = 'URL';
    openWindowMultipleInstance(
        "chrome://komodo/content/project/simplePartProperties.xul", 
        "komodo_urlproperties",
        "chrome,close=yes,modal=yes,resizable=yes", obj);
    if (obj.res) {
        var index = -1;
        if (typeof(item)=='undefined' || !item)
            item = gFocusedProjectView.getSelectedItem();
        if (item) index = gFocusedProjectView.getIndexByPart(item);    
        gFocusedProjectView.manager.addItem(part,index);
    }
}

peURL.prototype.onUpdatePart = function(part,event)
{
    if (part.type == 'URL') {
        part.renameable = true;
        part.iconstyle['URL'] = 1;
    }
}

function AddURLAtIndex(URLtext,index) {
    try {
        dump("in AddURL "+URLtext+"\n");
        var URL = Components.classes['@activestate.com/koPart?type=URL;1'].createInstance(Components.interfaces.koIPart_URL);
        URL.type = 'URL';
        var name = URLtext;
        var value = URLtext;
        if (URLtext.search("\n")) {
            var s = URLtext.split("\n");
            name = typeof(s[1])!='undefined'?s[1]:s[0];
            value = s[0];
        }
        URL.setStringAttribute('name', name);
        URL.value = value;
        gFocusedProjectView.manager.addItem(URL,index);
        //dump("leaving AddURL\n");
    } catch (e) {
        logError(e);
    }
}

function AddURL(URLtext) {
    AddURLAtIndex(URLtext,-1);
}

function CallNamedPart(name) {
    // This is called by the cmd_callNamedPart -- it dispatches to URLs and Directory shortcuts.
    // XXX: make it take over the RunNamedCommand, ExecuteNamedMacro etc.
    // there's no need to have a different function for each part type IMO.
    var part = toolboxMgr.findPartByAttributeValue('name', name);
    if (!part) {
        part = gProjectManager.findPartByAttributeValue('name', name);
    }
    if (!part) {
        alertDialog("Could not find a toolbox or project item called " + name);
        return;
    }
    switch (part.type) {
        case 'URL':
            OpenUrlInDefaultBrowser(part.value);
            break;
        case 'DirectoryShortcut':
            OpenDirectoryShortcut(part)
            break;
        default:
            alertDialog("Don't know how to launch items of type " + item.type);
            break;
    }
}