/* Copyright (c) 2000-2001 ActiveState SRL. 
   See the file LICENSE.txt for licensing information. */

/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * Komodo's Tip of the Day dialog
 *
 */


//---- globals

var _gParentWindow = opener;    // a hook back to the parent window
var _gNumTips = 24;
var _gPrefSvc = null;



//---- interface routines for tipoftheday.xul

function Tip_OnLoad(prefix)
{
    _gPrefSvc = Components.classes["@activestate.com/koPrefService;1"].
                getService(Components.interfaces.koIPrefService);
    if (document.getElementById("tipoftheday-window")) {
        var showAtStartup = _gPrefSvc.prefs.getBooleanPref("tipShowAtStartup");
        document.getElementById("show-tip-checkbox").checked = showAtStartup;
        document.getElementById("close-button").focus();
        SetWindowLocation();
    }
    Tip_NextTip(prefix);
}


function Tip_OnUnload()
{
    var showAtStartup = document.getElementById("show-tip-checkbox").checked;
    _gPrefSvc.prefs.setBooleanPref("tipShowAtStartup", showAtStartup);
    SaveWindowLocation();
}


function Tip_NextTip(prefix /* null */)
{
    // Get the current tip number and display that tip.
    var tipNumber = _gPrefSvc.prefs.getLongPref("tipNumber");
    if (typeof(prefix) == undefined || !prefix) {
        prefix = '';
    }
    var tipUrl = "chrome://komodo/content/tipoftheday/" + prefix + "tip" + tipNumber +
                 ".html";
    //dump("Tip_NextTip(): setting tip to " + tipUrl + "\n");
    document.getElementById("tip-content").setAttribute("src", tipUrl);
    
    // Increment the tip number.
    tipNumber = (Number(tipNumber) + 1) % _gNumTips;
    _gPrefSvc.prefs.setLongPref("tipNumber", tipNumber);
}

