from xpcom import components, ServerException

from koLanguageServiceBase import *

class koCSharpLanguage(KoLanguageBase):
    name = "C#"
    _reg_desc_ = "%s Language" % name
    _reg_contractid_ = "@activestate.com/koLanguage?language=%s;1" \
                       % (name)
    _reg_clsid_ = "{BC6A9F39-650F-48d4-B286-4D569DDB1F43}"

    defaultExtension = ".cs"
    
    def get_lexer(self):
        if self._lexer is None:
            self._lexer = KoLexerLanguageService()
            self._lexer.setLexer(components.interfaces.ISciMoz.SCLEX_CPP)
            self._lexer.setKeywords(0, self._keywords)
            self._lexer.supportsFolding = 1
        return self._lexer

    def getEncodingWarning(self, encoding):
        if not encoding.byte_order_marker and encoding.encoding_info.supports_byte_order_marker:
            return 'It is recommended that any %s file include a signature if it\'s encoding supports one' % self.name                
        else: # It's all good
            return ''
        
    _keywords = ["abstract", "as", "base", "bool", "break", "byte",
                 "case", "catch", "char", "checked", "class", "const", "continue",
                 "decimal", "default", "delegate", "do", "double", "else", "enum",
                 "event", "explicit", "extern", "false", "finally", "fixed",
                 "float", "for", "foreach", "goto", "if", "implicit", "in", "int",
                 "interface", "internal", "is", "lock", "long", "namespace", "new",
                 "null", "object", "operator", "out", "override", "params",
                 "private", "protected", "public", "readonly", "ref", "return",
                 "sbyte", "sealed", "short", "sizeof", "stackalloc", "static",
                 "string", "struct", "switch", "this", "throw", "true", "try",
                 "typeof", "uint", "ulong", "unchecked", "unsafe", "ushort",
                 "using", "virtual", "void", "while"] 

