from xpcom import components, ServerException

from koLanguageServiceBase import *

class koIDLLanguage(KoLanguageBase):
    name = "IDL"
    _reg_desc_ = "%s Language" % name
    _reg_contractid_ = "@activestate.com/koLanguage?language=%s;1" \
                       % (name)
    _reg_clsid_ = "{E9A451B7-E13D-4d71-883C-93BD457A3D9F}"

    defaultExtension = ".idl"
    commentDelimiterInfo = {
        "line": [ "//" ],
        "block": [ ("/*", "*/") ],
    }

    def get_lexer(self):
        if self._lexer is None:
            self._lexer = KoLexerLanguageService()
            self._lexer.setLexer(components.interfaces.ISciMoz.SCLEX_CPP)
            self._lexer.setKeywords(0, self._keywords)
            self._lexer.supportsFolding = 1
        return self._lexer

    def get_commenter(self):
        if self._commenter is None:
            self._commenter = KoCommenterLanguageService(
                self.commentDelimiterInfo)
        return self._commenter

    _keywords = [
                       # keywords appearing outside of brackets
                       "attribute", "boolean", "char", "const", "double", "float", "in", "inout",
                       "int", "interface", "long", "native", "octet", "out", "readonly", "string",
                       "unsigned", "void", "wchar", "wstring",
                       # keywords appearing inside brackets
                       "array", "nsid", "ptr", "ref", "retval", "scriptable", "shared",
                       "iid_is", "notxpcom", "noscript", "uuid"]

