from xpcom import components, ServerException

from koLanguageServiceBase import *

class koJavaLanguage(KoLanguageBase):
    name = "Java"
    _reg_desc_ = "%s Language" % name
    _reg_contractid_ = "@activestate.com/koLanguage?language=%s;1" \
                       % (name)
    _reg_clsid_ = "{A5907F34-F7CC-40ec-898A-551CBAA0557B}"

    defaultExtension = ".java"

    def get_lexer(self):
        if self._lexer is None:
            self._lexer = KoLexerLanguageService()
            self._lexer.setLexer(components.interfaces.ISciMoz.SCLEX_CPP)
            self._lexer.setKeywords(0, self._keywords)
            self._lexer.supportsFolding = 1
        return self._lexer


    _keywords = ["abstract", "boolean", "break", "byte", "case",
                 "catch", "char", "class", "const", "continue", "default", "do",
                 "double", "else", "extends", "final", "finally", "float", "for",
                 "future", "generic", "goto", "if", "implements", "import",
                 "inner", "instanceof", "int", "interface", "long", "native",
                 "new", "null", "operator", "outer", "package", "private",
                 "protected", "public", "rest", "return", "short", "static",
                 "super", "switch", "synchronized", "this", "throw", "throws",
                 "transient", "try", "var", "void", "volatile", "while"]
