from xpcom.server.enumerator import SimpleEnumerator
from xpcom import components, ServerException, Exception
from testable import MultiTestable

class Test1:
    _com_interfaces_ = [components.interfaces.koITestable]
    _reg_clsid_ = "{80B66D08-FF87-4ec4-AA8B-64B4A6202C99}"
    unitName = "test1"
    _reg_contractid_ = "@activestate.com/koTestable-" + unitName + ";1"

    def run(self):
        # this component passes all tests
        return 'PASS: nothing to report'

class Test2:
    _com_interfaces_ = [components.interfaces.koITestable]
    _reg_clsid_ = "{6F38D333-1A8C-462a-9A04-65CF69B52E08}"
    unitName = "test2"
    _reg_contractid_ = "@activestate.com/koTestable-" + unitName + ";1"

    def run(self):
        # this component fails! 
        return 'FAIL: Test ' + Test2.__name__ + ' failed!'

class Test3:
    _com_interfaces_ = [components.interfaces.koITestable]
    _reg_clsid_ = "{B88BC8DE-08AE-4570-B49F-D96F2F123D96}"
    unitName = 'test3'
    _reg_contractid_ = "@activestate.com/koTestable-" + unitName + ";1"
    def run(self):
        # this component fails! 
        return 'ABORT: Test ' + self.unitName + ' failed badly!'

class DynTest3:
    _com_interfaces_ = [components.interfaces.koITestable]
    _reg_clsid_ = "{AFA5D4CE-7C6D-43aa-9B52-F76E43FD8D2A}"
    unitName = 'dyntest'
    _reg_contractid_ = "@activestate.com/koTestable-" + unitName + ";1"

    def run(self):
        import testable
        testable._window.promptDialog("foo", "bar", "OK", "Cancel")
        return 'PASS'
    

class MultiTest(MultiTestable):
    _com_interfaces_ = [components.interfaces.koITestable,
                        components.interfaces.koIMultiTestable]
    _reg_clsid_ = "{BFF91556-4AAD-4186-A58A-4759315BC54A}"
    unitName = 'multitest1'
    _reg_contractid_ = "@activestate.com/koTestable-" + unitName + ";1"

    def test_foo(self):
        return "PASS: foo"
    def test_bar(self):
        return "PASS: bar"
    def test_zoe(self):
        return "FAIL: zoe"
    
    
